<?php
// ++=========================================================================++
// || vBadvanced Links Directory v1.0.1 (vB 3.5) - 17185
// ||  2003-2004 vBadvanced.com & PlurPlanet, LLC - All Rights Reserved
// || This file may not be redistributed in whole or significant part.
// || http://vbadvanced.com
// || Downloaded 14:49, Wed Oct 5th 2005
// || 3105590_051718507648
// ++ ========================================================================++

error_reporting(E_ALL & ~E_NOTICE);
define('NO_REGISTER_GLOBALS', 1);

$phrasegroups = array();
$specialtemplates = array();

$globaltemplates = array(
	'ADV_LINKS_ADD_EDIT',
	'adv_links_select',
	'adv_links_deletebit',
	'adv_links_addlink_custombits',
	'newpost_errormessage',
	'newpost_preview'
);

$actiontemplates['none'] = &$actiontemplates['addlink'];

require_once('./links_global.php');

if (empty($_REQUEST['do']))
{
	$_REQUEST['do'] = 'addlink';
}

// ###################### Function To Check Errors ###########################
function check_link_errors($dupe = 0)
{
	global $_POST, $db, $vba_options;

	$errors = array();

	if (!$_POST['catid'])
	{
		eval('$errors[] = "' . fetch_error('adv_links_must_choose_directory') . '";');
	}
	if ($_POST['url'] == 'http://' OR !$_POST['url'] OR !$_POST['name'] OR !$_POST['description'])
	{
		eval('$errors[] = "' . fetch_error('adv_links_missingfiled') . '";');
	}

	$urlcheck = substr(trim($_POST['url']), 0, 6);
	if (!in_array($urlcheck, array('http:/', 'https:', 'ftp://')))
	{
		$_POST['url'] = 'http://' . $_POST['url'];
	}

	if ($vba_options['links_verifynew'])
	{
		$geturl = @parse_url(trim($_POST['url'])); 
		$host = $geturl['host']; 
		$path = $geturl['path']; 

		if(!@fsockopen($host, 80, $errno, $errstr, 20))
		{
			eval('$errors[] = "' . fetch_phrase('adv_links_invalid_url', PHRASETYPEID_ERROR) . '";');
		}
	}

	if (!$vba_options['links_allowdupes'] AND $dupe)
	{
		function strip_url($linkurl)
		{
			$linkurl = str_replace(array('http://www.', 'http://'), '', $linkurl);
	
			if (substr($linkurl, strlen($linkurl) - 1, strlen($linkurl) - 1) == '/')
			{
				$linkurl = substr($linkurl, 0, strlen($linkurl) - 1);
			}
			return $linkurl;
		}
	
		$linkdomain = substr(strip_url($_POST['url']), 0, strrpos($_POST['url'], '.')); 
	
		$checkdupe = $db->query("SELECT url FROM " . TABLE_PREFIX . "links WHERE url LIKE '%$linkdomain%' " . iif(!$dupe, "AND linkid != '$_POST[linkid]'") . " LIMIT 1");
		while ($dupe = $db->fetch_array($checkdupe))
		{
			if (strip_url($dupe['url']) == strip_url($_POST['url']))
			{
				eval('$errors[] = "' . fetch_error('adv_links_duplicate', htmlspecialchars($_POST['url'])) . '";');
			}
		}
	}

	$cfields = array();
	$customfields = $db->query("SELECT * FROM " . TABLE_PREFIX . "links_customfields");
	while ($custom = $db->fetch_array($customfields))
	{
		$cfields[$custom[fieldid]] = $custom;
	}

	foreach ($cfields AS $field => $values)
	{
		$thisfield = 'field' . $field;
		if ($values['required'] AND empty($_POST["$thisfield"]))
		{
			eval('$errors[] = "' . fetch_error('requiredfieldmissing', $values['title']) . '";');
		}
	}

	return $errors;
}

// ############################### do add new ###############################
if ($_POST['do'] == 'doaddlink')
{
	$catid = $vbulletin->input->clean_gpc('p', 'catid', TYPE_INT);

	if (!$linksperms['canaddlinks']) 
	{ 
		print_no_permission(); 
	}

	$errors = check_link_errors(iif($vba_options['links_allowdupes'], 0, 1));

	$name = htmlspecialchars($_POST['name']);
	$description = htmlspecialchars($_POST['description']);
	$linkurl = htmlspecialchars($_POST['url']);
	$keywords = htmlspecialchars($_POST['keywords']);

	if ($errors)
	{
		require_once('./includes/functions_newpost.php');
		$linkerrors = construct_errors($errors);

		$unhtml_linkname = $name;

		$_REQUEST['do'] = 'addlink';
	}
	else
	{
		$valid = 0;
		if (!$linksperms['moderatelinks'])
		{
			$valid = 1;
		}

		$cat = $db->query_first("SELECT title, options, newlinkemail FROM " . TABLE_PREFIX . "links_categories WHERE catid = '$catid'");
		
		$sendmailto = explode(' ', $cat['newlinkemail']);

		$db->query_write("INSERT INTO " . TABLE_PREFIX . "links (catid, name, url, description, keywords, valid, open, username, userid, dateline) VALUES ('$catid', '" . addslashes($name) . "', '" . addslashes($linkurl) . "', '" . addslashes($description) . "', '" . addslashes($keywords) . "', '$valid', '1', '" . addslashes($vbulletin->userinfo['username']) . "', '" . $vbulletin->userinfo['userid'] . "', '" . time() . "')");

		$newlinkid = $db->insert_id();

		construct_customfields_sql($newlinkid);

		if (!$valid OR $vba_options['links_newlinkemail_all'])
		{
			if ($vba_options['links_newlinkemail'])
			{
				$optmailer = explode(' ', $vba_options['links_newlinkemail']);
				$sendmailto = array_merge($optmailer, $sendmailto);
			}
			
			if (!empty($sendmailto))
			{
				foreach ($sendmailto AS $email)
				{
					eval(fetch_email_phrases('adv_links_newlink', 0));
					vbmail(trim($email), $subject, $message);
				}
			}
		}

		if ($valid == 0)
		{
			eval(standard_error(fetch_error('adv_links_submitted', $vbulletin->session->vars['sessionurl_q'], $vba_options['links_title'])));
		}
		else
		{
			$db->query_write("UPDATE " . TABLE_PREFIX . "links_categories SET linkcount = linkcount+1, lastlinkid = '$newlinkid', lastposter = '" . addslashes($vbulletin->userinfo['username']) . "', lastlinktitle = '" . addslashes(htmlspecialchars($name)) . "', lastuserid = '" . $vbulletin->userinfo['userid'] . "', lastupdated = '" . time() . "' WHERE catid = '$catid'");
	
			$vbulletin->url = "showlink.php?$session[sessionurl]do=showdetails&amp;l=$newlinkid";
			eval(print_standard_redirect('adv_links_addednew'));
		}
	}
}

// ############################## Do Edit Link ################################
if ($_POST['do'] == 'doeditlink')
{
	$linkid = $vbulletin->input->clean_gpc('p', 'linkid', TYPE_INT);
	$catid = $vbulletin->input->clean_gpc('p', 'catid', TYPE_INT);
	$oldcatid = $vbulletin->input->clean_gpc('p', 'oldcatid', TYPE_INT);
	$name = $vbulletin->input->clean_gpc('p', 'name', TYPE_NOHTML);

	$link = $db->query_first("SELECT linkid, userid FROM " . TABLE_PREFIX . "links WHERE linkid = '$linkid'");

	if (($link['userid'] != $vbulletin->userinfo['userid'] AND !$linksperms['caneditotherslinks']) OR !$linksperms['caneditlinks'])
	{
		print_no_permission();
	} 

	$errors = check_link_errors(0);

	if ($errors)
	{
		$name = htmlspecialchars($_POST['name']);
		$description = htmlspecialchars($_POST['description']);
		$linkurl = htmlspecialchars($_POST['url']);
		$keywords = htmlspecialchars($_POST['keywords']);
		require_once('./includes/functions_newpost.php');
		$linkerrors = construct_errors($errors);

		$unhtml_linkname = $name;

		$_REQUEST['do'] = 'editlink';
	}
	else
	{

		$_POST['notes'] .= ' ' . $vbphrase['last_updated'] . ' ' . vbdate($vbulletin->options['dateformat'] . ' ' . $vbulletin->options['timeformat'], TIMENOW) . ' ' . $vbphrase['by'] . ' ' . $vbulletin->userinfo['username'];

		$db->query_write("UPDATE " . TABLE_PREFIX . "links SET catid = '$catid', name = '" . addslashes(htmlspecialchars($name)) . "', url = '" . addslashes(htmlspecialchars(trim($_POST['url']))) . "', description = '" . addslashes(htmlspecialchars($_POST['description'])) . "', keywords = '" . addslashes(htmlspecialchars($_POST['keywords'])) . "', lastupdated = '" . time() . "', notes = '" . addslashes($_POST['notes']) . "' WHERE linkid = '$linkid'");

		construct_customfields_sql($linkid, false);

		$catinfo = $db->query_first("SELECT lastlinkid FROM " . TABLE_PREFIX . "links_categories WHERE catid = '$catid'");

		if ($catinfo['lastlinkid'] == $linkid)
		{
			$db->query_write("UPDATE " . TABLE_PREFIX . "links_categories SET lastlinktitle = '" . addslashes(htmlspecialchars($name)) . "', lastupdated = '" . time() . "' WHERE catid = '$catid'");
		}

		if ($oldcatid != $catid)
		{
			update_count($catid);
			update_count($oldcatid);
		}

		$vbulletin->url = "showlink.php?$session[sessionurl]do=showdetails&amp;l=$link[linkid]";
		eval(print_standard_redirect('adv_links_linkedited'));
	}
}

// ############################### add a link ###############################
if ($_REQUEST['do'] == 'addlink')
{
	if (!$linksperms['canaddlinks'])
	{
	  print_no_permission();
	}

	$options = print_dir_select($catid, true, true);
     
	$navbits[''] = $vbphrase['submit_a_link'];
	$navbits = construct_navbits($navbits);
eval('$navbar = "' . fetch_template('navbar') . '";');

	$customfieldbits = construct_custom_fieldbits($_POST);

	if (defined('VBA_PORTAL'))
	{
		eval('$html = "' . fetch_template('ADV_LINKS_ADD_EDIT') . '";');
		print_portal_output($home, $html);
	}
	else
	{
		eval('print_output("' . fetch_template('ADV_LINKS_ADD_EDIT') . '");');
	}
}

// ############################## Edit Link ################################
if ($_REQUEST['do'] == 'editlink')
{

	$link = $db->query_first("
			SELECT linkid, name, links.description, links.catid, url, keywords, userid, notes, customfields.*, parentlist
			FROM " . TABLE_PREFIX . "links AS links
			LEFT JOIN " . TABLE_PREFIX . "links_customfields_entries AS customfields ON (links.linkid = customfields.lid)
			LEFT JOIN " . TABLE_PREFIX . "links_categories AS categories ON (links.catid = categories.catid)
			WHERE linkid = '$linkid'
	");

	if ($vbulletin->userinfo['userid'] == 0 OR (($link['userid'] != $vbulletin->userinfo['userid'] AND !$linksperms['caneditotherslinks']) OR !$linksperms['caneditlinks']) AND !is_directory_mod($link['parentlist']))
	{
		print_no_permission();
	}
	
	if (is_directory_mod($link['parentlist']))
	{
		$show['linknotes'] = true;
	}
	
	if (!$errors)
	{
		$unhtml_linkname = stripslashes($link['name']);
		$linkname = stripslashes($link['name']);
		$description = stripslashes($link['description']);
		$linkurl = stripslashes($link['url']);
		$keywords = stripslashes($link['keywords']);
	}

	if (($link['userid'] == $vbulletin->userinfo['userid'] AND $linksperms['candeletelinks']) OR $linksperms['candeleteotherslinks'] OR is_directory_mod($link['parentlist']))
	{
		eval('$deleteoption = "' . fetch_template('adv_links_deletebit') . '";');
	}

	$options = print_dir_select($link['catid'], true, true);

	$customfieldbits = construct_custom_fieldbits($link, '', true);

	$navbits = construct_dir_navbits($link['parentlist']);
	$navbits["showlink.php?$session[sessionurl]do=showdetails&amp;l=$link[linkid]"] = $linkname;
	$navbits[''] = $vbphrase['edit_link'];
	$navbits = construct_navbits($navbits);
eval('$navbar = "' . fetch_template('navbar') . '";');
	$show['editlink'] = true;

	if (defined('VBA_PORTAL'))
	{
		eval('$html = "' . fetch_template('ADV_LINKS_ADD_EDIT') . '";');
		print_portal_output($home, $html);
	}
	else
	{
		eval('print_output("' . fetch_template('ADV_LINKS_ADD_EDIT') . '");');
	}
}

// ########################### Delete Link ##############################
if ($_POST['do'] == 'dodeletelink')
{
	$linkid = $vbulletin->input->clean_gpc('p', 'linkid', TYPE_INT);
	$deletelink = $vbulletin->input->clean_gpc('p', 'deletelink', TYPE_INT);

	$link = $db->query_first("SELECT linkid, name, links.catid, userid, parentlist
			FROM " . TABLE_PREFIX . "links AS links
			LEFT JOIN " . TABLE_PREFIX . "links_categories AS categories USING (catid)
			WHERE linkid = '$linkid'
	");

	check_link_id($link['linkid']);

	if (($link['userid'] != $vbulletin->userinfo['userid'] AND !$linksperms['candeleteotherslinks']) OR !$linksperms['candeletelinks'] AND !is_directory_mod($link['parentlist']))
	{
		print_no_permission();
	}
	
	if (!$deletelink)
	{
		$type = $vbphrase['link'];
		eval(standard_error(fetch_error('adv_links_nodelete', $vbphrase['link'])));
	}
	else
	{
		delete_links($link['linkid']);

		update_count($link['catid']);

		$linkname = stripslashes($link['name']);
		$vbulletin->url = "browselinks.php?$session[sessionurl]c=$link[catid]";
		eval(print_standard_redirect('adv_links_deleted'));
	}	
}

?>