<?php
// ++=========================================================================++
// || vBadvanced Links Directory v1.0.1 (vB 3.5) - 17185
// ||  2003-2004 vBadvanced.com & PlurPlanet, LLC - All Rights Reserved
// || This file may not be redistributed in whole or significant part.
// || http://vbadvanced.com
// || Downloaded 14:49, Wed Oct 5th 2005
// || 3105590_051718507648
// ++ ========================================================================++

error_reporting(E_ALL & ~E_NOTICE);
define('NO_REGISTER_GLOBALS', 1);
define('VBA_SCRIPT', 'links_directory');

require_once('./links_config.php');

chdir($forumpath);

$specialtemplates = array_merge(
	array(
		'links_d_cache',
		'links_mod_cache',
		'adv_links_opts',
		'links_ugroups'
	),
	$specialtemplates
);

$globaltemplates = array_merge(
	array(
		'adv_links_navbar',
		'adv_links_directoryjump',
		'adv_links_footer'
	),
	$globaltemplates
);

$phrasegroups = array_merge(array('adv_links'), $phrasegroups);

if ($redirect)
{
	header("Location: $redirect");
	exit;
}

require_once('./global.php');

require_once('./includes/functions_links.php');

// Set vBa options & merge w/ vBa CMPS if necessary
$vba_options = array_merge(iif(empty($vba_options), array(), $vba_options), unserialize($vbulletin->adv_links_opts));

$directorycache = unserialize($vbulletin->links_d_cache);

// ################################ Replacements ##############################
$vbulletin->templatecache['STANDARD_ERROR'] = str_replace(
	array(
		'"login.php',
		'"register.php'
	),
	array(
		'"' . $vbulletin->options['bburl'] . '/login.php',
		'"' . $vbulletin->options['bburl'] . '/register.php'
	),
	$vbulletin->templatecache['STANDARD_ERROR']
);

// $headinclude replacement
if (!defined('VBA_PORTAL'))
{
	$headinclude = str_replace(
		array(
			'"clientscript',
			'url(images/',
			'name="generator" content="'
		),
		array(
			'"' . $vbulletin->options['bburl'] . '/clientscript',
			'url(' . $vbulletin->options['bburl'] . '/images/',
			'name="generator" content="vBadvanced, '
		),
		$headinclude
	);
}

$vbulletin->templatecache['STANDARD_ERROR'] = str_replace(
	array(
		'"login.php',
		'"register.php'
	),
	array(
		'"' . $vbulletin->options['bburl'] . '/login.php',
		'"' . $vbulletin->options['bburl'] . '/register.php'
	),
	$vbulletin->templatecache['STANDARD_ERROR']
);

// $navbar replacement
$navreplacearray = explode("\r\n", $vba_options['global_navbar_replace']);

$navreplace['find'] = array( 
	'"clientscript', 
	'\'misc.php', 
	'$GLOBALS[\'vbulletin\']->options[\'bbtitle\']', 
	'$GLOBALS[\'vbulletin\']->options[\'forumhome\'] . ".php' 
); 

$navreplace['replace'] = array( 
	'"' . $vbulletin->options['bburl'] . '/clientscript', 
	'\'' . $vbulletin->options['bburl'] . '/misc.php', 
	iif($vba_options['links_navbarhomelink'], '$vbulletin->options[hometitle]', '$vba_options[links_title]'), 
	iif($vba_options['links_navbarhomelink'], '$vbulletin->options[homeurl] . "', '$vba_options[links_homeurl] . "/index.php')
);

$navreplace = construct_replacement_array($navreplacearray, $navreplace);

$vbulletin->templatecache['navbar'] = str_replace($navreplace['find'], $navreplace['replace'], $vbulletin->templatecache['navbar']);
$vbphrase['private_messages_nav'] = str_replace('"private.php', '"' . $vbulletin->options['bburl'] . '/private.php', $vbphrase['private_messages_nav']);

// $footer replacement
$footerreplacearray = explode("\r\n", $vba_options['global_footer_replace']);

$footerreplace['find'] = array(
	'"' . $admincpdir . iif($vba_options['portal_replaceadmin'], '/index.php'),
	'"' . $modcpdir,
);

$footerreplace['replace'] = array(
	'"' . $vbulletin->options['bburl'] . '/' . $admincpdir . iif($vba_options['portal_replaceadmin'], '/vba_cmps_admin.php'),
	'"' . $vbulletin->options['bburl'] . '/' . $modcpdir,
);

$footerreplace = construct_replacement_array($footerreplacearray, $footerreplace);

eval('$footer = "' . fetch_template('adv_links_footer') . '";');
eval('$footer .= "' . fetch_template('footer') . '";');

$footer = str_replace($footerreplace['find'], $footerreplace['replace'], $footer) .  '<' . '!' . '-- ' . 'P' . 'ow' . chr(101) . 'r' . chr(101) . chr(100) . ' ' . 'b' . trim($xmsquar) . 'y v' . chr(98) . 'a' . chr(100) . 'v' . '' . 'a' . '' . 'nc' . chr(101) . chr(100) . ' -->';

if ($shownewpm)
{
	eval('$pmscript = "' . fetch_template('pm_popup_script') . '";');
	$footer .= str_replace('"private.php', '"' . $vbulletin->options['bburl'] . '/private.php', $pmscript);
}

// $header replacement
$headerreplacearray = explode("\r\n", $vba_options['global_header_replace']);

$headerreplace['find'] = array();
$headerreplace['replace'] = array();

$headerreplace = construct_replacement_array($headerreplacearray, $headerreplace);

$header = str_replace($headerreplace['find'], $headerreplace['replace'], $header);

$links_permissions = unserialize($vbulletin->links_ugroups);

// ########################## Links Permissions #############################
$vbulletin->userinfo['usergrouparray'] = fetch_membergroupids_array($vbulletin->userinfo);

if (empty($vbulletin->userinfo['usergrouparray']))
{
	$vbulletin->userinfo['usergrouparray'] = array(1);
}

foreach ($vbulletin->userinfo['usergrouparray'] AS $usergroupid)
{
	if (empty($links_permissions["$usergroupid"]))
	{
		$usergroupid = 1;
	}

	foreach ($linkspermissionsbit AS $option => $value)
	{
		if (in_array($option, array('moderateimages', 'moderateposts')) AND $linksperms["$option"] == 0 AND isset($linksperms["$option"]))
		{
			continue;
		}
		if (!$linksperms["$option"] OR in_array($option, array('moderatelinkposts', 'moderatelinks')))
		{
			$linksperms["$option"] = 0;
			if ($links_permissions["$usergroupid"]['links_perms'] & $value)
			{
				$linksperms["$option"] = 1;
			}
		}
	}

	foreach ($links_permissions["$usergroupid"] AS $option => $value)
	{
		if (((($value > $linksperms["$option"] AND $linksperms["$option"] != '0') OR !$value) AND $option != 'links_perms'))
		{
			$linksperms["$option"] = $value;
		}
	}
}

// Check main permissions
if (!$linksperms['canviewlinksdir'])
{
	print_no_permission();
}

// First element of navbar
if (THIS_SCRIPT != 'linksindex' AND $vba_options['links_navbarhomelink'])
{
	$navbits["$vba_options[links_homeurl]/index.php"] = $vba_options['links_title'];
}

// ###################### Show Variables ##############################
if ($vba_options['links_allowreplies'] AND $linksperms['canreplytolinks'])
{
	$show['replylink'] = true;
}
if ($linksperms['canratelinks'])
{
	$show['ratelink'] = true;
}
if ($linksperms['cansearchlinks'])
{
	$show['searchlinks'] = true;
}
if ($linksperms['cansendlinktofriend'])
{
	$show['sendtofriend'] = true;
}
if ($vba_options['links_browsedropdown'])
{
	$show['linkbit_popup'] = true;
}
if ($vba_options['links_showmodcolumn'])
{
	$show['modcolumn'] = true;
}
if ($vba_options['links_allowsubscribe'] AND $vbulletin->userinfo['userid'])
{
	$show['subscribe'] = true;
}
if ($vba_options['links_allowfav'] AND $vbulletin->userinfo['userid'])
{
	$show['favorites'] = true;
}

$links_modcache = unserialize($vbulletin->links_mod_cache);

if ($permissions['adminpermissions'] & $vbulletin->bf_ugp_adminpermissions['cancontrolpanel'])
{
	$show['modoptions'] = true;
}
else if (!empty($link_modcache))
{
	foreach ($link_modcache AS $moderator)
	{
		if ($moderator['userid'] == $vbulletin->userinfo['userid'])
		{
			$show['modoptions'] = true;
		}
	}
}

// ############################# Common Globals ############################
$linkid = $vbulletin->input->clean_gpc('r', 'linkid', TYPE_INT);
$l = $vbulletin->input->clean_gpc('r', 'l', TYPE_INT);

if (!isset($_POST['catid']))
{
	$catid = $vbulletin->input->clean_gpc('r', 'catid', TYPE_NOHTML);
	$c = $vbulletin->input->clean_gpc('r', 'c', TYPE_NOHTML);
}

if (isset($l) AND $l != 0)
{
	$linkid = $l;
}

if (isset($c) AND $c != 0)
{
	$catid = $c;
}

// ######################### Links Navbar Width ##########################
$lnavrows = 3;
if ($show['favorites'] OR $show['subscribe'])
{
	$lnavrows++;
}
if ($vba_options['links_newlinklimit'])
{
	$lnavrows++;
}
if ($vba_options['links_poplinklimit'])
{
	$lnavrows++;
}
if ($vba_options['links_linktous'])
{
	$show['link_to_us'] = true;
	$lnavrows++;
}
if ($show['modoptions'])
{
	$lnavrows++;
}

$lnavbarwidth = intval(100 / $lnavrows) . '%';

eval('$linksnav = "' . fetch_template('adv_links_navbar') . '";');

$directorycache = unserialize($vbulletin->links_d_cache);

?>