<?php
// ++=========================================================================++
// || vBadvanced Links Directory v1.0.1 (vB 3.5) - 17185
// ||  2003-2004 vBadvanced.com & PlurPlanet, LLC - All Rights Reserved
// || This file may not be redistributed in whole or significant part.
// || http://vbadvanced.com
// || Downloaded 14:49, Wed Oct 5th 2005
// || 3105590_051718507648
// ++ ========================================================================++

error_reporting(E_ALL & ~E_NOTICE);
define('NO_REGISTER_GLOBALS', 1);
define('THIS_SCRIPT', 'search');

$globaltemplates = array();
$specialtemplates = array();

$actiontemplates = array(
	'search' => array(
		'ADV_LINKS_SEARCH'
	),
	'searchresults' => array(
		'ADV_LINKS_RESULTS',
		'adv_links_linkbit'
	)
);

$actiontemplates['none'] = &$actiontemplates['search'];

$phrasegroups = array('search');

require_once('./links_global.php');

if (empty($_REQUEST['do']))
{
	$_REQUEST['do'] = 'search';
}

if (!$linksperms['cansearchlinks'])
{
	print_no_permission();
}

// ############################### Search results ###############################
if ($_REQUEST['do'] == 'searchresults')
{
	$searchid = $vbulletin->input->clean_gpc('r', 'searchid', TYPE_INT);
	$pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_INT);

	require_once('./includes/functions_search.php');
	require_once('./includes/functions_misc.php');

	if ($searchid)
	{
		$search = $db->query_first("SELECT * FROM " . TABLE_PREFIX . "links_search WHERE searchid = '$searchid'");
		$countlinks['count'] = $search['numresults'];
		if (!$search['searchid'])
		{
			eval(standard_error(fetch_error('searchnoresults')));
		}

		$orderby = $search['orderby'];
		$doorderby = construct_orderby();
	
		if ($orderby == 'rating')
		{
			$votequery = 'IF(votenum >= ' . $vbulletin->options['showvotes'] . ', votenum, 0) AS votenum, IF(votenum >= ' . $vbulletin->options['showvotes'] . ' AND votenum> 0, votetotal / votenum, 0) AS voteavg,';
		}
	
		if ($search['direction'] != 'ASC')
		{
			$search['direction'] = 'DESC';
		}
	
		$search['keywords'] = explode(' ', stripslashes($search['string']));
		foreach ($search['keywords'] AS $key => $keyword)
		{
			if ($key > 0)
			{
				$comma = ',';
			}
			$keywords .= "$comma <b><u>$keyword</u></b>";
		}				

		if ($search['username'])
		{
			$search['username'] = unserialize($search['username']);
			foreach ($search['username'] AS $userid => $username)
			{
				$search['usernames']["$userid"] = '<a href="' . $vbulletin->options['bburl'] . '/member.php?u=' . $userid . '"><b><u>' . $username . '</b></u></a>';
			}
			$search['usernames'] = implode(' ' . $vbphrase['or'] . ' ', $search['usernames']);
		}

		$catinfo['title'] = $vbphrase['search'];
		$navname = $vbphrase['search_results'];

		if (!intval($pagenumber))
		{
			$pagenumber = 1;
		}

		$perpage = intval($vba_options['links_perpage']);
		$minlimit = ($pagenumber - 1) * $perpage + 1;
		$maxlimit = $pagenumber * $perpage;
	
		if ($maxlimit > $search['numresults'])
		{
	  	$maxlimit = $search['numresults'];
	    if ($minlimit > $search['numresults'])
	    {
		    $minlimit = $search['numresults'] - $perpage;
		  }
	  }
	
	  if ($minlimit <= 0)
	  {
		  $minlimit = 1;
	  }
		
		if ($vba_options['links_allowsubscribe'] AND $vbulletin->userinfo['userid'])
		{
			$query['subfields'] = ', NOT ISNULL(subscribelink.linkid) AS subid';
			$query['subjoin'] = 'LEFT JOIN ' . TABLE_PREFIX . 'links_subscribelink AS subscribelink ON (links.linkid = subscribelink.linkid AND ' . $vbulletin->userinfo['userid'] . ' = subscribelink.userid)';
		}
	
		if ($vba_options['links_allowreplies'] AND $linksperms['canviewlinkreplies'])
		{
			$query['postfields'] = ', posts, lastpostdateline, lastpostuserid, lastpostusername';
		}
	
		if ($vbulletin->userinfo['userid'] AND $vba_options['links_allowfav'])
		{
			$query['favfields'] = ', NOT ISNULL(favorites.linkid) AS favid';
			$query['favjoin'] = 'LEFT JOIN ' . TABLE_PREFIX . 'links_favorites AS favorites ON (favorites.linkid = links.linkid AND favorites.userid = ' . $vbulletin->userinfo['userid'] . ')';
		}
	
		if (!$linksperms['canviewprivatedirs'])
		{
			$privdirs = fetch_private_directories();
			if ($privdirs)
			{
				$query['privatedirs'] = 'AND links.catid NOT IN(' . $privdirs . ')';
			}
		}
	
		// Get Links
		$getlinks = $db->query("SELECT $votequery links.linkid, name, links.description, url, links.catid, views, links.username, links.userid, links.dateline, open, votenum, votetotal, links_categories.title $query[postfields] $query[subfields] $query[favfields]
				FROM " . TABLE_PREFIX . "links AS links
				LEFT JOIN " . TABLE_PREFIX . "links_categories AS links_categories ON (links.catid = links_categories.catid) 
				$query[postjoin]
				$query[subjoin]
				$query[favjoin]
				WHERE suspended = 0 AND valid = 1 AND links.linkid IN($search[linkids]) $query[privatedirs]
				GROUP BY links.linkid
				ORDER BY $doorderby $search[direction]
				LIMIT " . ($minlimit - 1) . ", $perpage");
		if ($db->num_rows($getlinks))
		{
			$adv_sorturl = construct_adv_sort_url($search['searchid']);
			$show['directoryhead'] = true;
			$highlight['string'] = $search['string'];
			$highlight['fields'] = $search['sfields'];
			$highlight['wholeword'] = $search['wholeword'];
			$returnto = 'searchresults';
			unset($query);
			while ($links = $db->fetch_array($getlinks))
			{
				$linkbits .= construct_linkbits($links, $highlight);
			} 
			$db->free_result($getlinks);
			unset($links);
		}
		else
		{
			$name = $vbphrase['links'];
			eval('$linkbits = "' . fetch_template('adv_links_nodisplay') . '";');
		}
	
		$pagenav = construct_page_nav($pagenumber, $perpage, $search['numresults'], "search.php?$session[sessionurl]do=searchresults&amp;searchid=$search[searchid]");
	
		$navbits[''] = $navname;
		$navbits = construct_navbits($navbits);
eval('$navbar = "' . fetch_template('navbar') . '";');
	
		$show['search_results'] = true;
		$show['dir_search'] = false;

		$directoryjump = print_directory_jump('search');

		if (defined('VBA_PORTAL'))
		{
			eval('$html = "' . fetch_template('ADV_LINKS_RESULTS') . '";');
			print_portal_output($home, $html);
		}
		else
		{
			eval('print_output("' . fetch_template('ADV_LINKS_RESULTS') . '");');
		}
	}
	else
	{
		$catids = $vbulletin->input->clean_gpc('r', 'catids', TYPE_ARRAY);
		$fields = $vbulletin->input->clean_gpc('r', 'fields', TYPE_ARRAY);
		$cfields = $vbulletin->input->clean_gpc('r', 'cfields', TYPE_ARRAY);
		$string = $vbulletin->input->clean_gpc('r', 'string', TYPE_NOHTML);
		$orderby = $vbulletin->input->clean_gpc('r', 'orderby', TYPE_NOHTML);
		$direction = $vbulletin->input->clean_gpc('r', 'direction', TYPE_NOHTML);
		$username = $vbulletin->input->clean_gpc('r', 'username', TYPE_NOHTML);
		$subdirs = $vbulletin->input->clean_gpc('r', 'subdirs', TYPE_INT);
		$quicksearch = $vbulletin->input->clean_gpc('r', 'quicksearch', TYPE_INT);
		$dateline = $vbulletin->input->clean_gpc('r', 'dateline', TYPE_INT);

		$starttimecounter = microtime();

		if ($checksearch = $db->query_first("SELECT searchid FROM " . TABLE_PREFIX . "links_search WHERE userid = '" . $vbulletin->userinfo['userid'] . "' AND dateline > " . (TIMENOW - $vbulletin->options['searchfloodtime']) . ""))
		{
			eval(standard_error(fetch_error('searchfloodcheck', $vbulletin->options['searchfloodtime'], ($vbulletin->options['searchfloodtime'] - (TIMENOW - $checksearch['dateline'])))));
		}

		if ($quicksearch)
		{
			$fields = array('name', 'keywords', 'description');
			$subdirs = 1;
		}

	  if (!$string AND !$username)
	  {
			eval(standard_error(fetch_error('searchspecifyterms')));
		}

		if (empty($fields) AND empty($cfields))
		{
			eval(standard_error(fetch_error('adv_gallery_error_no_search_fields')));
		}

		if (!empty($fields))
		{
			$sfields = $fields;
		}

		if (!empty($cfields))
		{
			$sfields = array_merge($sfields, $cfields);
			$cfjoin = 'LEFT JOIN ' . TABLE_PREFIX . 'links_customfields_entries AS customfields ON (links.linkid = customfields.lid)';
		}

		$fields = implode(',', $sfields);

		if ($string)
		{
			$searchstring = explode(' ', $string);

			$condition = '(';
			
			$strcount = 0;
			foreach ($searchstring AS $sstring)
			{
				$concount = 0;
				$strcount++;
				if ($strcount > 1)
				{
					$condition .= '(';
				}
				foreach ($sfields AS $value)
				{
					$concount++;
					if ($concount > 1)
					{
						$condition .= ' OR ';
					}

					if ($_REQUEST['matchwholeword'])
					{
						$condition .= "$value LIKE '% " . sanitize_word_for_sql($sstring) . " %'";
					}
					else
					{
						$condition .= "$value LIKE '%" . sanitize_word_for_sql($sstring) . "%'";
					}
				}
				$condition .= ') AND ';
			}
		}
		
		if (in_array('pagetext', $sfields))
		{
			$postjoin = 'LEFT JOIN ' . TABLE_PREFIX . 'links_posts AS posts ON (posts.linkid = links.linkid)';
		}

		if ($username)
		{
			if (!$exactname AND strlen($username) < 3)
			{
				eval(standard_error(fetch_error('searchnametooshort')));
			}

			$username = sanitize_word_for_sql($username);

			$getuserids = $db->query("SELECT userid, username FROM " . TABLE_PREFIX . "user WHERE username " . iif($exactname, '= ' . $username, 'LIKE \'%' . $username . '%\''));
			if ($db->num_rows($getuserids))
			{
				$users = array();
				while ($userinfo = $db->fetch_array($getuserids))
				{
					$users["$userinfo[userid]"] = $userinfo['username'];
				}
			}
			else
			{
				eval(standard_error(fetch_error('invalidid', $vbphrase['user'])));
			}
			$userids = implode(',', array_keys($users));
			$condition .= ' (links.userid IN(' . $userids . ')' . iif (in_array('pagetext', $sfields), ' OR posts.userid IN(' . $userids . ')') . ') AND';

		}

		if ($dateline)
		{
			if ($_POST['new_old'] == 'older')
			{
				$arr = '<=';
			}
			else
			{
				$arr = '>=';
			}

			if ($dateline == 'lastvisit')
			{
				$condition .= ' links.dateline ' . $arr . ' ' . $vbulletin->userinfo['lastvisit'] . ' AND';
			}
			else
			{
				$cutoffdate = time() - ($dateline * 86400);
				$condition .= " links.dateline $arr $cutoffdate AND";
			}
			unset($arr);
		}
		if ($_POST['replycount'] OR $_POST['leastmost'] == 'most')
		{
			if ($_POST['leastmost'] == 'least')
			{
				$arr = '>=';
			}
			else
			{
				$arr = '<=';
			}
			$condition .= ' posts ' . $arr . ' ' . intval($_POST['replycount']) . ' AND';
		}

		if (empty($catids) AND $catids != 0)
		{
			eval(standard_error(fetch_error('adv_links_search_nocat')));
		}

		if (!empty($catids) AND in_array('favorites', $catids))
		{
			$searchquery = "
					SELECT links_favorites.linkid
					FROM " . TABLE_PREFIX . "links_favorites AS links_favorites
					LEFT JOIN " . TABLE_PREFIX . "links AS links USING (linkid)
					$postjoin
					$cfjoin
					WHERE suspended = 0 AND $condition valid = 1
			";
		}
		else
		{
			if (!empty($catids) AND $catids != array(0))
			{
				if ($subdirs)
				{
					$newcatinfo = array();
					
					foreach ($catids AS $scats)
					{
						$newcatinfo[] = $scats;
						$findsubs = construct_directories($directorycache, $scats, 0);
						if (!empty($findsubs))
						{
							foreach ($findsubs AS $cats)
							{
								$newcatinfo[] = $cats['catid'];
							}
						}
						else
						{
							$newcatinfo[] = $scats;
						}
						$cids = implode(',', $newcatinfo);
					}
				}
				else
				{
					$cids = implode(',', $catids);
				}
	
				$condition .= " links.catid IN($cids) AND ";
			}
		
			$searchquery = "
					SELECT links.linkid
					FROM " . TABLE_PREFIX . "links AS links
					$postjoin
					$cfjoin
					WHERE suspended = 0 AND $condition valid = 1
			";
		}	
		// Get Links
		$getlinks = $db->query($searchquery);

		if ($debug)
		{
			$linksnav .= '<table width="100%"><tr><td>' . $searchquery . '</td></tr></table><br />';
		}

		if ($db->num_rows($getlinks))
		{
			$linkcount = 0;
			while ($links = $db->fetch_array($getlinks))
			{
				$linkcount++;
				$linkidarray[] = $links['linkid'];
			} 
		}
		else
		{
			eval(standard_error(fetch_error('searchnoresults', '')));
		}

		$countlinks['count'] = $linkcount;

		$db->free_result($getlinks);
		unset($links);

		if (!empty($linkidarray))
		{
			$linkarray = implode(',', $linkidarray);

			if (!empty($users))
			{
				$usernames = serialize($users);
			}

			$db->query_write("INSERT INTO " . TABLE_PREFIX . "links_search (string, username, sfields, catids, dateline, userid, linkids, orderby, direction, wholeword, numresults, searchtime) VALUES ('" . addslashes(htmlspecialchars($string)) . "', '$usernames', '$fields', '$catids', '" . time() . "', '" . $vbulletin->userinfo['userid'] . "', '$linkarray', '" . addslashes(htmlspecialchars($orderby)) . "', '" . addslashes(htmlspecialchars($direction)) . "', '$_REQUEST[matchwholeword]', '$linkcount', '" . number_format(fetch_microtime_difference($starttimecounter), 3) . "')");

			$searchid = $db->insert_id();

			$vbulletin->url = 'search.php?do=searchresults&amp;searchid=' . $searchid;
			eval(print_standard_redirect('search'));

		}
	}
}


// ############################### Main search page ###############################
if ($_REQUEST['do'] == 'search')
{
	$navbits[''] = $vbphrase['search'];
	$navbits = construct_navbits($navbits);
eval('$navbar = "' . fetch_template('navbar') . '";');

	if (!$catid)
	{
		$selected[0] = 'selected="selected"';
	}

	if ($vba_options['links_allowreplies'])
	{
		$counter = 1;
	}
	else
	{
		$counter = 0;
	}

	$customfields = $db->query("
			SELECT fieldid, title 
			FROM " . TABLE_PREFIX . "links_customfields 
			WHERE searchable = 1
			ORDER BY displayorder
	");
	while ($field = $db->fetch_array($customfields))
	{
		$counter++;
		if ($counter == 2)
		{
			$customfieldboxes .= '</tr><tr>';
			$counter = 0;
		}
		eval('$customfieldboxes .= "' . fetch_template('adv_links_search_custombits') . '";');
	}

	$directorylist = print_dir_select($catid, false);

	if (defined('VBA_PORTAL'))
	{
		eval('$html = "' . fetch_template('ADV_LINKS_SEARCH') . '";');
		print_portal_output($home, $html);
	}
	else
	{
		eval('print_output("' . fetch_template('ADV_LINKS_SEARCH') . '");');
	}
}


?>