<?php
// ++=========================================================================++
// || vBadvanced Links Directory v1.0.1 (vB 3.5) - 17185
// ||  2003-2004 vBadvanced.com & PlurPlanet, LLC - All Rights Reserved
// || This file may not be redistributed in whole or significant part.
// || http://vbadvanced.com
// || Downloaded 14:49, Wed Oct 5th 2005
// || 3105590_051718507648
// ++ ========================================================================++

error_reporting(E_ALL & ~E_NOTICE);
define('NO_REGISTER_GLOBALS', 1);

$globaltemplates = array();

$actiontemplates = array(
	'showdetails' => array(
		'ADV_LINKS_SHOWLINK',
		'adv_links_ratingbit',
		'adv_links_showlink_custombits',
		'adv_links_showlink_keywordbit',
		'bbcode_quote',
		'postbit',
		'postbit_buttons',
		'postbit_ip',
		'postbit_onlinestatus',
		'postbit_reputation',
		'showthread_quickreply'
	)
);

$specialtemplates = array(
	'bbcodecache',
	'iconcache',
	'smiliecache'
);

$phrasegroups = array('postbit', 'showthread', 'posting');

require_once('./links_global.php');

if (empty($_REQUEST['do']))
{
	$_REQUEST['do'] = 'showlink';
}

if (!$linksperms['canviewlinks'])
{
	print_no_permission();
}

// ############################### Go to URL ###############################
if ($_REQUEST['do'] == 'showlink')
{
	check_link_id($linkid);

	$db->query_write("UPDATE LOW_PRIORITY " . TABLE_PREFIX . "links SET views = views+1 WHERE linkid = '$linkid'");
	$transfer = $db->query_first("SELECT name, url FROM " . TABLE_PREFIX . "links WHERE linkid = '$linkid'");

	$linkname = $transfer['name'];
	$vbulletin->url = $transfer['url'];

	eval(print_standard_redirect('adv_links_transferring'));
}

// ############################### View link details ###############################
if ($_REQUEST['do'] == 'showdetails')
{
	$pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_INT);
	$perpage = $vbulletin->input->clean_gpc('r', 'perpage', TYPE_INT);
	$postid = $vbulletin->input->clean_gpc('r', 'postid', TYPE_INT);
	$searchid = $vbulletin->input->clean_gpc('r', 'searchid', TYPE_INT);
	$goto = $vbulletin->input->clean_gpc('r', 'goto', TYPE_NOHTML);
	$orderby = $vbulletin->input->clean_gpc('r', 'orderby', TYPE_NOHTML);

	if ($goto == 'lastpost')
	{
		$getlast = $db->query_first("SELECT postid FROM " . TABLE_PREFIX . "links_posts WHERE linkid = '$linkid' ORDER BY postid DESC");
		exec_header_redirect("showlink.php?$session[sessionurl_js]do=showdetails&amp;l=$linkid&amp;p=$getlast[postid]#post$getlast[postid]");
	}

	else if ($goto == 'next' OR $goto == 'previous')
	{
		if (($orderby == 'name' OR empty($orderby)) AND !$direction)
		{
			$direction = 'ASC';
		}

		if ($_REQUEST['catid'] == 'searchresults')
		{
			$search = $db->query_first("SELECT * FROM " . TABLE_PREFIX . "links_search WHERE searchid = '$_REQUEST[searchid]'");
			$orderby = $search['orderby'];
			$direction = $search['direction'];
			if (!$search['searchid'])
			{
				eval(standard_error(fetch_error('searchnoresults')));
			}
		}

		if ($direction != 'ASC')
		{
			$direction = 'DESC';
		}

		$doorderby = construct_orderby();

		if ($orderby == 'rating')
		{
			$votequery = 'IF(votenum >= ' . $vbulletin->options['showvotes'] . ', votenum, 0) AS votenum, IF(votenum >= ' . $vbulletin->options['showvotes'] . ' AND votenum> 0, votetotal / votenum, 0) AS voteavg,';
		}
	
		if ($doorderby == 'name' AND !$direction)
		{
			$direction = 'ASC';
		}
	
		// Figure out which directory we're dealing with
		switch ($_REQUEST['catid'])
		{
			// User Favorites
			case 'favorites':
		
				$joinquery = ' LEFT JOIN ' . TABLE_PREFIX . 'links_favorites AS favorites USING (linkid)';
				$linkquery = ' AND favorites.userid = \'' . $vbulletin->userinfo['userid'] . '\' ORDER BY ' . $doorderby . ' ' . $direction;
				break;

			// User Subscriptions
			case 'subscriptions':
		
				$joinquery = ' LEFT JOIN ' . TABLE_PREFIX . 'links_subscribelink AS subscribe USING (linkid)';
				$linkquery = ' AND subscribe.userid = \'' . $vbulletin->userinfo['userid'] . '\' ORDER BY ' . $doorderby . ' ' . $direction;
				break;
		
			// Popular Links
			case 'poplinks':
				if ($doorderby == 'name')
				{
					$doorderby = 'views';
				}
				$linkquery = 'ORDER BY ' . $doorderby . ' DESC LIMIT ' . $vba_options['links_poplinklimit'];
				break;

			// New Links
			case 'newlinks':
				$linkquery = 'ORDER BY dateline DESC LIMIT ' . $vba_options['links_newlinklimit'];
				break;
		
			// Member Search
			case 'member':
				$linkquery = ' AND userid = \'' . intval($_REQUEST['linkuserid']) . '\' ORDER BY ' . $doorderby . ' ' . $direction;
				break;

			case 'searchresults':
				$linkquery = ' AND linkid IN (' . $search['linkids'] . ') ORDER BY ' . $doorderby . ' ' . $direction;
				break;
			

			// Directory ID
			default:
				$cat = intval($_REQUEST['catid']);

				// In case of a reply, there won't be a catid... Assume we're in browselinks
				if (!$cat)
				{
					$getcat = $db->query_first("SELECT catid FROM " . TABLE_PREFIX . "links WHERE linkid = '$linkid'");
					$cat = $getcat['catid'];
				}

				$linkquery = 'AND catid = \'' . $cat . '\' ORDER BY ' . $doorderby . ' ' . $direction;
		}
	
		$counter = 0;
		$linkarray = array();
		$getids = $db->query("
				SELECT $votequery links.linkid 
				FROM " . TABLE_PREFIX . "links AS links $joinquery 
				" . iif($orderby == 'directory', 'LEFT JOIN ' . TABLE_PREFIX . 'links_categories AS links_categories USING (catid)') . "
				WHERE valid = 1 AND suspended = 0 $linkquery
		");
		while($prevnext = $db->fetch_array($getids))
		{
			$counter ++;
			$linkarray[] = $prevnext['linkid'];
		} 
	
		$key = array_search($linkid, $linkarray);
		if ($goto == 'next')
		{
			if (isset($linkarray[$key+1]))
			{
				$linkid = $linkarray[$key+1]; 
			}
			else
			{
				$linkid = $linkarray[0];
			}
		}
		else
		{
			if (isset($linkarray[$key-1]))
			{
				$linkid = $linkarray[$key-1];
			}
			else
			{
				$linkid = $linkarray[$counter-1];
			}
		}
	}
	if ($vbulletin->userinfo['userid'] AND $vba_options['links_allowfav'])
	{
		$query['favfields'] = ',NOT ISNULL(links_favorites.linkid) AS favid';
		$query['favjoin'] = 'LEFT JOIN ' . TABLE_PREFIX . 'links_favorites AS links_favorites ON (links_favorites.linkid = links.linkid AND links_favorites.userid = ' . $vbulletin->userinfo['userid'] . ')';
	}

	if ($show['subscribe'])
	{
		$query['subfields'] = ',NOT ISNULL(subscribelink.linkid) AS issubscribed';
		$query['subjoin'] = 'LEFT JOIN ' . TABLE_PREFIX . 'links_subscribelink AS subscribelink ON (subscribelink.linkid = links.linkid AND subscribelink.userid = ' . $vbulletin->userinfo['userid'] . ')';
	}

	$link = $db->query_first("
			SELECT links.*, customfields.*, title, parentlist, options $query[favfields] $query[subfields]
			FROM " . TABLE_PREFIX . "links AS links
			$query[favjoin]
			$query[subjoin]
			LEFT JOIN " . TABLE_PREFIX . "links_customfields_entries AS customfields ON (links.linkid = customfields.lid)
			LEFT JOIN " . TABLE_PREFIX . "links_categories AS links_categories ON (links.catid = links_categories.catid)
			WHERE links.linkid = '$linkid'
	");

	unset($query);

	check_link_id($link['linkid']);

	check_directory_permissions($link['catid']);

	$show['modopts'] = is_directory_mod($link['parentlist']);

	if (($link['suspended'] OR !$link['valid']) AND !$show['modopts'])
	{
		eval(standard_error(fetch_error('noid', $vbphrase['link'])));
	}

	$link['name'] = stripslashes($link['name']);
	$link['description'] = stripslashes($link['description']);
	$link['directory'] = stripslashes($link['title']);
	$link['username'] = stripslashes($link['username']);
	$link['views'] = number_format($link['views']);
	$link['dateadded'] = vbdate($vbulletin->options['dateformat'], $link['dateline']);
	$link['timeadded'] = vbdate($vbulletin->options['timeformat'], $link['dateline']);
	$link['keywords'] = stripslashes($link['keywords']);

	if ($searchid)
	{
		$search = $db->query_first("SELECT string, sfields, wholeword FROM " . TABLE_PREFIX . "links_search WHERE searchid = '$searchid'");

		$sfields = explode(',', $search['sfields']);

		if (in_array('description', $sfields))
		{
			$link['description'] = highlight_keywords($link['description'], $search['string'], $search['wholeword']);
		}
	}

	$diropts = construct_dir_opts($link['catid'], $link['options']);

	require_once('./includes/class_bbcode.php');
	$bbcode_parser =& new vB_BbCodeParser($vbulletin, fetch_tag_list());

	$customfields = $db->query("SELECT * FROM " . TABLE_PREFIX . "links_customfields ORDER BY displayorder");
	while ($field = $db->fetch_array($customfields))
	{
		$bgclass = exec_switch_bg();
		$thisfield = 'field' . $field['fieldid'];

		$field['value'] = $bbcode_parser->do_parse(unhtmlspecialchars($link["$thisfield"]), $diropts['allow_custom_html'], $diropts['allow_custom_smilies'], $diropts['allow_custom_bbcode'], $diropts['allow_custom_bbimgcode']);
		if ($searchid)
		{
			if (in_array($thisfield, $sfields))
			{
				$field['value'] = highlight_keywords($link["$thisfield"], $search['string'], $search['wholeword']);
			}
		}
		eval('$customfieldbits .= "' . fetch_template('adv_links_showlink_custombits') . '";');
	}
	$db->free_result($customfields);
	unset($field);

	if ($link['keywords'])
	{
		if ($vba_options['links_convertkeywords'])
		{
			$kwords = explode(' ', trim($link['keywords']));
			$link['keywords'] = '';
			foreach ($kwords AS $keyword)
			{
				if ($keywords)
				{
					$comma = ',';
				}

				if ($searchid)
				{
					if (in_array('keywords', $sfields))
					{
						$link['keyword'] = highlight_keywords($keyword, $search['string'], $search['wholeword']);
					}
				}

				eval('$link[\'keywords\'] .= "$comma ' . fetch_template('adv_links_showlink_keywordbit') . '";');
			}
		}
	}
	else
	{
		$link['keywords'] = $vbphrase['none'];
	}

	if (substr($link['username'], -1) != 's')
	{ 
		$plurals = $vbphrase['plural_s']; 
	} 

	if ($link['votetotal'])
	{
		$link['truerating'] = number_format($link['votetotal'] / $link['votenum'], 2);
		$link['roundrating'] = round($link['truerating']);
	}
	else
	{
		$link['truerating'] = 0;
	}

	if (!$link['open'])
	{
		$show['closedbutton'] = true;
	}

	$adv_sorturl = construct_adv_sort_url();

	// ######################### Replies to Link #############################
	if ($vba_options['links_allowreplies'] AND $linksperms['canviewlinkreplies'] AND $diropts['open_for_posts'])
	{
		if ($vbulletin->userinfo['maxposts'] != -1)
		{
			$perpage = $vbulletin->userinfo['maxposts'];
		}

		if (!intval($perpage)) 
		{
			$perpage = $vba_options['links_repliesperpage'];
		}

		if ($_REQUEST['p'])
		{
			$postid = intval($_REQUEST['p']);
		}

		if ($postid)
		{
			$pages = $db->query_first("SELECT COUNT(*) AS count FROM " . TABLE_PREFIX . "links_posts WHERE postid < '$postid' AND linkid = '$link[linkid]'");
			$pagenumber = ceil(($pages['count'] + 1) / $perpage);
		}
	
		if (!intval($pagenumber))
		{
		 	$pagenumber = 1;
		}
		$counter = 0;
		$perpage = intval($perpage);
		$lowerlimit = ($pagenumber-1) * $perpage + 1;
		$upperlimit = ($pagenumber) * $perpage;
		
		$countreplies = $db->query_first("SELECT COUNT(*) AS count FROM " . TABLE_PREFIX . "links_posts WHERE linkid = '$link[linkid]' AND visible = 1");
	
		if ($countreplies['count'] > 0)
		{
			$show['reputationlink'] = false;
			if ($upperlimit > $countreplies['count'])
			{
				$upperlimit = $countreplies['count'];
				if ($lowerlimit > $countreplies['count'])
				{
					$lowerlimit = $countreplies['count'] - $perpage;
				}
			}
			if ($lowerlimit <= 0)
			{
				$lowerlimit = 1;
			}
	
			$pagenav = construct_page_nav($pagenumber, $perpage, $countreplies['count'], 'showlink.php?' . $session['sessionurl'] . 'do=showdetails&amp;l=' . $link['linkid'] . '' . construct_adv_sort_url());
		
			$counter = 0;
			$postcount = ($pagenumber - 1 ) * $perpage;
			$show['postheader'] = true;

			if ($vba_options['links_showquickreply'] AND $show['replylink'] AND $link['open'])
			{
				$SHOWQUICKREPLY = true;
			}

			require_once('./includes/functions_bigthree.php');
			require_once('./includes/class_postbit.php');

			// Icons
			if ($vba_options['links_allowicons'])
			{
				$query['iconfields'] = ', posts.iconid, icon.title as icontitle, icon.iconpath';
				$query['iconjoin'] = 'LEFT JOIN ' . TABLE_PREFIX . 'icon AS icon ON (posts.iconid = icon.iconid)';
			}

			// Avatars
			if ($vbulletin->options['avatarenabled'])
			{
				$query['avatarfields'] = ',avatar.avatarpath, NOT ISNULL(customavatar.filedata) AS hascustom, customavatar.dateline AS avatardateline, avatarrevision';
				$query['avatarjoin'] = 'LEFT JOIN ' . TABLE_PREFIX . 'avatar AS avatar ON (avatar.avatarid = user.avatarid)
					LEFT JOIN ' . TABLE_PREFIX . 'customavatar AS customavatar ON (customavatar.userid = user.userid)';
			}

			// Reputation 
			if ($vbulletin->options['reputationenable'])
			{
				$query['repfields'] = ', level';
				$query['repjoin'] = 'LEFT JOIN ' . TABLE_PREFIX . 'reputationlevel AS reputationlevel ON (user.reputationlevelid = reputationlevel.reputationlevelid)';
			}

			// Smilies
			if ($diropts['allow_post_smilies'])
			{
				$query['getsmilie'] = true;
			}

			$postcount = ($pagenumber - 1) * $perpage;
			$show['postcount'] = true;

			$posts = $db->query("
					SELECT posts.postid, posts.pagetext, posts.title, posts.userid, posts.username AS postusername, posts.dateline, posts.ipaddress AS ip " . iif($query['getsmilie'], ', posts.allowsmilie') . " ,posts.showsignature, user.*, userfield.*, usertextfield.signature $query[iconfields] $query[avatarfields] $query[repfields]
					FROM " . TABLE_PREFIX . "links_posts AS posts 
					LEFT JOIN " . TABLE_PREFIX . "user AS user ON (posts.userid = user.userid) 
					LEFT JOIN " . TABLE_PREFIX . "userfield AS userfield ON (posts.userid = userfield.userid) 
					LEFT JOIN " . TABLE_PREFIX . "usertextfield AS usertextfield ON (usertextfield.userid = posts.userid)
					$query[avatarjoin]
					$query[iconjoin]
					$query[repjoin]
					WHERE linkid = '$link[linkid]' AND posts.visible = 1
					ORDER BY posts.dateline
					LIMIT " . ($lowerlimit - 1) . ", $perpage
			");
			if ($db->num_rows($posts))
			{

				unset($query);
				while ($post = $db->fetch_array($posts))
				{
			    $post['message'] = $bbcode_parser->do_parse($post['pagetext'], $diropts['allow_post_html'], $post['allowsmilie'], $diropts['allow_post_bbcode'], $diropts['allow_post_bbimgcode']);
			    $post['postdate'] = vbdate($vbulletin->options['dateformat'], $post['dateline']);
			    $post['posttime'] = vbdate($vbulletin->options['timeformat'], $post['dateline']);
					$post['title'] = stripslashes($post['title']);
	
					if (empty($checkperms[$post['userid']]))
					{
						$checkperms[$post['userid']] = cache_permissions($post, false);
					}
	
					if ($searchid)
					{
						if (in_array('pagetext', $sfields))
						{
							$post['message'] = highlight_keywords($post['message'], $search['string'], $search['wholeword']);
						}
					}
	
					$post['postcount'] = ++$postcount;
	
					// Status Icon
					$post['statusicon'] = 'old';
					if ($post['dateline'] > $vbulletin->userinfo['lastvisit'])
					{
						$post['statusicon'] = 'new';
					}
	
					$show['messageicon'] = false;
	
					// Post Icon
					if ($post['iconid'] OR $vbulletin->options['showdeficon'])
					{
						$show['messageicon'] = true;
					}
					if ($vbulletin->options['showdeficon'] AND !$post['iconid'])
					{
						$post['iconpath'] = $vbulletin->options['showdeficon'];
						$post['icontitle'] = $vbphrase['default'];
					}
					
					// Set default $show variables
					$show['profile'] = false;
					$show['avatar'] = false;
					$show['buddy'] = false;
					$show['search'] = false;
					$show['emaillink'] = false;
					$show['pmlink'] = false;
					$show['homepage'] = false;
					$show['reputation'] = false;
	
					// Show IP address
					$post['iplogged'] = '';
					if ($post['ip'])
					{
						if ($vbulletin->options['logip'] == 2)
						{
							$show['ip'] = true;
						}
						else if ($vbulletin->options['logip'] == 1 AND is_directory_mod($post['catid']))
						{
							$show['ip'] = false;
						}
						eval('$post[\'iplogged\'] .= "' . fetch_template('postbit_ip') . '";');
					}		
	
					if ($post['userid'])
					{
						// Post was by a user
						$post = array_merge($post, convert_bits_to_array($post['options'], $vbulletin->bf_misc_useroptions));
	
						$post['musername'] = fetch_musername($post);
	
						$show['profile'] = true;
						$show['buddy'] = true;
						$show['search'] = true;
	
						// Email, homepage, & PM links
						if ($post['showemail'] AND $vbulletin->options['displayemails'])
						{
							$show['emaillink'] = true;
						}
						if ($post['homepage'] AND $post['homepage'] != 'http://')
						{
							$show['homepage'] = true;
						}
						if ($vbulletin->options['enablepms'] AND $post['receivepm'])
						{
							$show['pmlink'] = true;
						}
	
						// Report link
						$show['reportlink'] = false;
						if ($vbulletin->userinfo['userid'] != $post['userid'])
						{
							$show['reportlink'] = true;
						}
	
						// User stats
				    $post['joindate'] = vbdate($vbulletin->options['registereddateformat'], $post['joindate']);
						$post['posts'] = number_format($post['posts']);
	
						// Online Status
						fetch_online_status($post, true);
	
						// Reputation
						if ($vbulletin->options['reputationenable'])
						{
							fetch_reputation_image($post, $checkperms);
							$show['reputation'] = true;
						}
	
						// Im Icons
						construct_im_icons($post);
	
						// User Title
						if ($post['customtitle'] == 2)
						{
							$post['usertitle'] = htmlspecialchars_uni($post['usertitle']);
						}
	
						// Signature
						if ($vbulletin->options['allowsignatures'] AND $post['showsignature'] AND $post['signature'] AND ($vbulletin->userinfo['showsignatures'] OR !$vbulletin->userinfo['userid']))
						{
							$post['signature'] = $bbcode_parser->parse($post['signature'], 0, $vbulletin->options['allowsmilies']);
						}
						else
						{
							$post['signature'] = '';
						}
		
						// Get Avatar
						$show['avatar'] = false;
						$post['avatarurl'] = '';
						if ($vbulletin->userinfo['showavatars'] OR !$vbulletin->userinfo['userid'])
						{
					  	if ($post['avatarpath'])
					  	{
						    $post['avatarurl'] = $vbulletin->options['bburl'] . '/' . $post['avatarpath'];
					    }
							else if ($post['hascustom'])
							{
								if ($vbulletin->options['usefileavatar'])
								{
									$post['avatarurl'] = $vbulletin->options['bburl'] . '/' . $vbulletin->options['avatarurl'] . '/avatar' . $post['userid'] . '_' . $post['avatarrevision'] . '.gif';
								}
								else
								{
									$post['avatarurl'] = $vbulletin->options['bburl'] . '/image.php?' . $vbulletin->session->vars['sessionurl_q'] . 'u=' . $post['userid'] . '&amp;dateline=' . $post['avatardateline'];
								}
							}
							if ($post['avatarurl'])
							{
								$show['avatar'] = true;
							}
						}
						if ($linksperms['caneditlinkposts'] AND $post['userid'] == $vbulletin->userinfo['userid'] OR $linksperms['caneditotherslinkposts'])
						{
							$post['editlink'] = 'reply.php?' . $session['sessionurl'] . 'do=editpost&amp;p=' . $post['postid'];
						}				
					}
					else
					{
						// Guest Post
						$post['posts'] = 'n/a';
						$post['username'] = $post['postusername'];
						$post['musername'] = fetch_musername($post);
						$post['usertitle'] = $vbphrase['guest'];
					}
	
					// Print the postbit
					eval('$postbits = "' . fetch_template('postbit') . '";');
	
					// Replace links and add $bburl
					$postbit .= str_replace(
						array(
							'"editpost.php',
							'"image.php',
							'imwindow',
							'"member.php',
							'"newreply.php',
							'"private.php',
							'"profile.php',
							'"sendmessage.php',
							'"report.php?',
							'"search.php',
							'"showpost.php?p=' . $post['postid'] . '&amp;postcount=' . $post['postcount']
						), 
						array(
							'"reply.php',
							'"' . $vbulletin->options['bburl'] . '/image.php',
							'openimwindow',
							'"' . $vbulletin->options['bburl'] . '/member.php',
							'"reply.php',
							'"' . $vbulletin->options['bburl'] . '/private.php',
							'"' . $vbulletin->options['bburl'] . '/profile.php',
							'"' . $vbulletin->options['bburl'] . '/sendmessage.php',
							'"misc.php?do=report&amp;type=post&amp;',
							'"' . $vbulletin->options['bburl'] . '/search.php',
							'"showlink.php?do=showdetails&amp;l=' . $link['linkid'] . '&amp;p=' . $post['postid'] . '#post' . $post['postid']
						),
						$postbits);
	
				}
			}
		}
	}

	if ($vba_options['links_showquickreply'] AND $show['replylink'] AND $link['open'] AND $vbulletin->userinfo['userid'])
	{
		require_once('./includes/functions_editor.php');

		$show['quickreply'] = true;
		$show['wysiwyg'] = ($diropts['allow_post_bbcode'] ? is_wysiwyg_compatible() : 0);
		$istyles_js = construct_editor_styles_js();
		$editorid = construct_edit_toolbar('', 0, 0, ($diropts['allow_post_smilies'] ? 1 : 0), 1, false, 'qr');
		$threadedmode = 0;
		$qrpostid = 'who cares';
		$QRrequireclick = 0;
	
		$vbulletin->templatecache['editor_clientscript'] = str_replace('"clientscript', '"' . $vbulletin->options['bburl'] . '/clientscript', $vbulletin->templatecache['editor_clientscript']);
		
		$vBeditJs = construct_editor_js_arrays();
		eval('$vBeditTemplate[\'clientscript\'] = "' . fetch_template('editor_clientscript') . '";');
	
		$headinclude .= '
			<!-- set up CSS for the editor -->
			<link rel="stylesheet" type="text/css" href="' . $vbulletin->options['bburl'] . '/clientscript/vbulletin_editor.css" />
			<style type="text/css">
			<!--
			#vBulletin_editor {
				background: ' . $istyles['pi_button_normal'][0] . ';
				padding: ' . $stylevar['cellpadding'] . 'px;
			}
			#controlbar, .controlbar {
				background: ' . $istyles['pi_button_normal'][0] . ';
			}
			.imagebutton {
				background: ' . $istyles['pi_button_normal'][0] . ';
				color: ' . $istyles['pi_button_normal'][1] . ';
				padding: ' . $istyles['pi_button_normal'][2] . ';
				border: ' . $istyles['pi_button_normal'][3] . ';
			}
			-->
			</style>
		';
	
		unset($threadid);
	
		eval('$quickreply = "' . fetch_template('showthread_quickreply') . '";');
	
		$messagearea = "
			<script type=\"text/javascript\">
			<!--
				var threaded_mode = $threadedmode;
				var require_click = 0;
				var is_last_page = " . iif(ceil($countimages['count'] / $perpage) == $pagenumber, 1, 0) . ";
				var ajax_last_post = '';
			// -->
			</script>
			$messagearea
		";
		
	}
	$directoryjump = print_directory_jump($link['catid']);

	switch($catid)
	{
		case 'favorites':
			$navbits["browselinks.php?$session[sessionurl]do=favorites"] = $vbphrase['my_favorites'];
			break;
	
		case 'subscriptions':
			$navbits["browselinks.php?$session[sessionurl]do=subscriptions"] = $vbphrase['my_subscriptions'];
			break;

		case 'newlinks':
			$navbits["browselinks.php?$session[sessionurl]do=newlinks"] = $vbphrase['whats_new'];
			break;
	
		case 'poplinks':
			$navbits["browselinks.php?$session[sessionurl]do=poplinks"] = $vbphrase['whats_popular'];
			break;
	
		default:
			$navbits = construct_dir_navbits($link['parentlist']);
	}

	$navbits[''] = $link['name'];

	$navbits = construct_navbits($navbits);
eval('$navbar = "' . fetch_template('navbar') . '";');

	if (defined('VBA_PORTAL'))
	{
		eval('$html = "' . fetch_template('ADV_LINKS_SHOWLINK') . '";');
		print_portal_output($home, $html);
	}
	else
	{
		eval('print_output("' . fetch_template('ADV_LINKS_SHOWLINK') . '");');
	}
}

?>