<?php
// ++=========================================================================++
// || vBadvanced Links Directory v1.0.1 (vB 3.5) - 17185
// ||  2003-2004 vBadvanced.com & PlurPlanet, LLC - All Rights Reserved
// || This file may not be redistributed in whole or significant part.
// || http://vbadvanced.com
// || Downloaded 14:49, Wed Oct 5th 2005
// || 3105590_051718507648
// ++ ========================================================================++

error_reporting(E_ALL & ~E_NOTICE);
define('NO_REGISTER_GLOBALS', 1);

$directoryopts = array(
	'open_for_links' => 1,
	'open_for_posts' => 2,
	'allow_post_html' => 4,
	'allow_post_bbcode' => 8,
	'allow_post_smilies' => 16,
	'allow_post_icons' => 32,
	'allow_post_bbimgcode' => 64,
	'allow_post_icons' => 128,
	'allow_custom_html' => 256,
	'allow_custom_bbcode' => 512,
	'allow_custom_smilies' => 1024,
	'allow_custom_icons' => 2048,
	'allow_custom_bbimgcode' => 4096
);

$linkspermissionsbit = array(
	'canviewlinks'							=> 1,
	'canaddlinks'								=> 2,
	'caneditlinks'        			=> 4,
	'caneditotherslinks'			  => 8,
	'candeletelinks' 						=> 16,
	'candeleteotherslinks'			=> 32,
	'moderatelinks'							=> 64,
	'canreplytolinks'						=> 128,
	'canviewlinkreplies'				=> 256,
	'cansearchlinks'						=> 512,
	'cansendlinktofriend'			 	=> 1024,
	'canratelinks' 							=> 2048,
	'caneditlinkposts'					=> 4096,
	'caneditotherslinkposts'		=> 8192,
	'candeletelinkposts'				=> 16384,
	'candeleteotherslinkposts'	=> 32768,
	'canviewlinksdir'						=> 65536,
	'canviewprivatedirs'				=> 131072,
	'moderatelinkposts'					=> 262144
);

// ########################## Construct Categories ############################
function construct_directories($catinfo, $cat = 0)
{
	global $counter;

	if ($catinfo)
	{
		foreach ($catinfo AS $cats)
		{
			if ($cats['parent'] == $cat)
			{
				$counter++;
				$cats['level'] = $counter;

				$catarray[] = $cats;

				if ($subcat = construct_directories($catinfo, $cats['catid']))
				{
					$catarray = array_merge($catarray, $subcat);
				}
				$counter--;
			}
		}
	}
	return $catarray;
}

// ###################### Function to Construct Categories #####################
function construct_directory_counters($catinfo, $cat = 0, $stoplevel = 1)
{
	global $counter;

	if ($catinfo)
	{
		foreach ($catinfo AS $cats)
		{
			if ($cats['parent'] == $cat)
			{
				$counter++;
				$cats['level'] = $counter;
				if (!$cats['haslinks'] AND $stoplevel != '-1')
				{
					$stopat = $stoplevel + 1;
				}
				if ($subcat = construct_directory_counters($catinfo, $cats['catid'], $stoplevel))
				{
					foreach ($subcat AS $subs)
					{
						$cats['linkcount'] += $subs['linkcount'];
						$cats['postcount'] += $subs['postcount'];
	
						if ($subs['lastupdated'] > $cats['lastupdated'])
						{
							$cats['lastupdated'] = $subs['lastupdated'];
							$cats['lastlinkid'] = $subs['lastlinkid'];
							$cats['lastposter'] = $subs['lastposter'];
							$cats['lastuserid'] = $subs['lastuserid'];
							$cats['lastlinktitle'] = $subs['lastlinktitle'];
						}
					}
					$catarray[] = $cats;
					if ($cats['level'] < intval($stopat) OR $stoplevel == '-1')
					{
						$catarray = array_merge($catarray, $subcat);
					}
				}
				else
				{
					$catarray[] = $cats;
				}
				$counter--;
			}
		}
	}
	return $catarray;
}

// ################### Function to Print Categories ########################
function print_directories($cat = 0, $catinfo = '', $subscriptions = false)
{
	global $db, $linksperms, $vba_options, $vbcollapse, $vbulletin, $stylevar, $vbphrase, $show;

	if (is_array($catinfo))
	{
		$catinfo = construct_directories($catinfo, $cat, 1);
	}
	else
	{
		$catinfo = array();
		$getcats = $db->query("
				SELECT catid, title, description, parent, haslinks, parentlist, private
				" . iif($linksperms['canviewlinks'], ', linkcount, postcount, lastlinkid, lastlinktitle, lastposter, lastuserid, lastupdated') . "
				FROM " . TABLE_PREFIX ."links_categories
				ORDER BY displayorder ASC, haslinks
		");
		while ($categories = $db->fetch_array($getcats))
		{
			echo $catinfo['title'];
			$catinfo[] = $categories;
		}

		$catinfo = construct_directory_counters($catinfo, $cat, 1);
		if (empty($catinfo))
		{
			return;
		}

		$db->free_result($getcats);
		unset($categories);
	}

	if (!empty($catinfo))
	{
		$links_modcache = cache_links_mods();
		foreach ($catinfo AS $cats)
		{
			if ($cats['private'] AND !$linksperms['canviewprivatedirs'])
			{
				continue;
			}

			$catcount++;

			$cats['title'] = stripslashes($cats['title']);
			$cats['description'] = stripslashes($cats['description']);

			if ($cats['haslinks'] == 1)
			{
				if ($show['modcolumn'])
				{
					foreach (explode(',', $cats['parentlist']) AS $parentid)
					{
						if ($links_modcache["$parentid"])
						{
							foreach ($links_modcache["$parentid"] AS $moderator)
							{
								if (!$donemods["$cats[catid]"]["$moderator[userid]"])
								{								
									$donemods["$cats[catid]"]["$moderator[userid]"] = true;

									$comma = '';
									if (!empty($cats['moderator']))
									{
										$comma = ', ';
									}
	
									eval('$cats[\'moderator\'] .= "$comma' . fetch_template('forumhome_moderator') . '";');
								}
							}
						}
					}
				}
				$cats['moderator'] = str_replace('"member.php', '"' . $vbulletin->options['bburl'] . '/member.php', $cats['moderator']);
				$cats['linkcount'] = number_format($cats['linkcount']);
				$cats['postcount'] = number_format($cats['postcount']);

				if ($vbulletin->userinfo['lastvisit'] < $cats['lastupdated'])
				{
					$onoff = 'new';
				}
				else
				{
					$onoff = 'old';
				}

				if ($cats['lastupdated'])
				{
					$cats['lastupdateddate'] = vbdate($vbulletin->options['dateformat'], $cats['lastupdated']);
					$cats['lastupdatedtime'] = vbdate($vbulletin->options['timeformat'], $cats['lastupdated']);
					$cats['lastposter'] = stripslashes($cats['lastposter']);
					$cats['lastlinktitle'] = fetch_trimmed_title(stripslashes($cats['lastlinktitle']), $vba_options['links_lastlink_maxlength']);
				}

				if ($cats['level'] == 0)
				{
					$cats['level'] = 1;
				}

				eval('$directorybits .= "' . fetch_template('adv_links_directorybit_level' . $cats['level']) . '";');
			}
			else
			{
				$catcollapse = $vbcollapse["collapseobj_dirbit_" . $cats['catid'] . ""];
				$catimgcollapse = $vbcollapse["collapseimg_dirbit_" . $cats['catid'] . ""];

				eval('$directorybits .= "' . fetch_template('adv_links_directorybit_main') . '";');
			}
		}
		unset($catinfo, $cats);
	}

	return $directorybits;
}

// ############################ Cache Moderators ############################
function cache_links_mods()
{
	global $vbulletin, $links_modcache;

	if (!empty($links_modcache))
	{
		foreach ($linkmods AS $moderator)
		{
			$moderator['musername'] = fetch_musername($moderator);
			$links_modcache["$moderator[catid]"]["$moderator[userid]"] = $moderator;
		}
	}
	return $links_modcache;
}

// ########################### Delete Links #############################
function delete_links($linkarray)
{
	global $db;
	if (is_array($linkarray))
	{
		$dellinks = implode(',', $linkarray);
	}
	else
	{
		$dellinks = $linkarray;
	}
	$db->query_write("DELETE FROM " . TABLE_PREFIX . "links WHERE linkid IN ($dellinks)");
	$db->query_write("DELETE FROM " . TABLE_PREFIX . "links_posts WHERE linkid IN ($dellinks)");
	$db->query_write("DELETE FROM " . TABLE_PREFIX . "links_favorites WHERE linkid IN ($dellinks)");
	$db->query_write("DELETE FROM " . TABLE_PREFIX . "links_subscribelink WHERE linkid IN ($dellinks)");
	$db->query_write("DELETE FROM " . TABLE_PREFIX . "links_customfields_entries WHERE lid IN ($dellinks)");
}

// ###################### Construct Orderby #######################
function construct_orderby()
{
	global $orderby, $vba_options, $direction;
	switch($orderby) 
	{
		case 'name':
			break;
		case 'dateline':
			break;
		case 'directory':
			$doorderby = 'links_categories.title';
			break;
		case 'lastpostdateline':
			break;
		case 'linkid':
			break;
		case 'posts':
			break;
		case 'rating':
			$doorderby = 'voteavg ' . $direction . ', votenum';
			break;
		case 'views':
			break;
		default:
			$doorderby = $vba_options['links_deforder'];
	}
	if (!$doorderby)
	{
		$doorderby = $orderby;
	}
	return $doorderby;
}

// ######################### Find Directory Mods #########################
function is_directory_mod($catarray)
{
	global $vbulletin, $permissions;

	if ($permissions['adminpermissions'] & $vbulletin->bf_ugp_adminpermissions['cancontrolpanel'])
	{
		return true;
	}
	else
	{
		$links_modcache = cache_links_mods();
	
		foreach (explode(',', $catarray) AS $parentid)
		{
			if ($links_modcache["$parentid"])
			{
				foreach($links_modcache["$parentid"] AS $moderator)
				{
					if ($vbulletin->userinfo['userid'] == $moderator['userid'])
					{
						return true;
					}
				}
			}
		}
	}
}	

// #################### Check Link ID ##########################
function check_link_id($linkid)
{
	global $vbphrase;

	if (!$linkid)
	{
		eval(standard_error(fetch_error('noid', $vbphrase['link'])));
	}
}

// ########################## Highlight Keywords #########################
function highlight_keywords($string, $keywords, $wholeword)
{
	if ($keywords)
	{
		$words = explode(' ', $keywords);
		
		foreach ($words as $word)
		{
			if ($wholeword)
			{
				$word = ' ' . $word . ' ';
			}
			$position = 0;
			
			while ($position !== false)
			{
				$position = strpos(strtolower($string), strtolower($word), $position);
				
				if ($position !== false)
				{
					$replace_string = substr($string, $position, strlen($word));
					
					$replace_string = '<span class="highlight">' . $replace_string . '</span>';
					
					$string = substr_replace($string, $replace_string, $position, strlen($word));
					
					$position = $position + strlen($replace_string);
				}		
			}
		}
	}
	return $string;
}

// #################### Construct Linkbit ######################
function construct_linkbits($link, $highlight = '')
{
	global $vba_options, $stylevar, $vbulletin, $vbphrase, $returnto, $show, $adv_sorturl, $catid;

	$link['name'] = stripslashes($link['name']);
	$link['description'] = stripslashes($link['description']);
	$link['username'] = stripslashes($link['username']);
	$link['updatedate'] = vbdate($vbulletin->options['dateformat'], $link['dateline']);
	$link['updatetime'] = vbdate($vbulletin->options['timeformat'], $link['dateline']);
	$link['category'] = stripslashes($link['title']);
	$link['replies'] = number_format($link['posts']);
	$link['views'] = number_format($link['views']);
	$link['lastpostdate'] = vbdate($vbulletin->options['dateformat'], $link['lastpostdateline']);
	$link['lastposttime'] = vbdate($vbulletin->options['timeformat'], $link['lastpostdateline']);
	$link['lastpostusername'] = stripslashes($link['lastpostusername']);

	if ($highlight)
	{
		$sfields = explode(',', $highlight['fields']);

		if (in_array('description', $sfields))
		{
			$link['description'] = highlight_keywords($link['description'], $highlight['string'], $highlight['wholeword']);
		}
		if (in_array('name', $sfields))
		{
			$link['name'] = highlight_keywords($link['name'], $highlight['string'], $highlight['wholeword']);
		}				
	}

	if (!$link['open'])
	{
		$link['folder'] = 'thread_lock';
	}
	elseif (($vbulletin->userinfo['lastvisit'] < $link['dateline'] OR $vbulletin->userinfo['lastvisit'] < $link['lastpostdateline']) AND ($link['views'] >= $vba_options['links_hotviews'] OR $links['posts'] >= $vba_options['links_hotposts']) AND ($vba_options['links_hotviews'] OR $vba_options['links_hotposts']))
	{
		$link['folder'] = 'thread_hot_new';
	}
	elseif (($vbulletin->userinfo['lastvisit'] < $link['dateline'] OR $vbulletin->userinfo['lastvisit'] < $link['lastpostdateline']) AND $link['views'] < $vba_options['links_hotviews'])
	{
		$link['folder'] = 'thread_new';
	}
	elseif (($link['views'] >= $vba_options['links_hotviews'] OR $link['posts'] >= $vba_options['links_hotposts']) AND ($vba_options['links_hotviews'] OR $vba_options['links_hotposts']))
	{
		$link['folder'] = 'thread_hot';
	}
	else
	{
		$link['folder'] = 'thread';
	}

	$show['sticky'] = false;
	if ($link['sticky'])
	{
		$show['sticky'] = true;
	}

	$show['subscribed'] = false;
	if ($link['subid'])
	{
		$show['subscribed'] = true;
	}

	$show['link_rating'] = false;
	if ($link['votetotal'] AND $link['votenum'] AND $show['ratelink'])
	{
		$link['truerating'] = number_format($link['votetotal'] / $link['votenum'], 2);
		$link['roundrating'] = round($link['truerating']);
		$show['link_rating'] = true;
	}

	eval('$linkbits .= "' . fetch_template('adv_links_linkbit') . '";');
	return $linkbits;
}

// ############################## Update Directory Cache ######################
function update_directory_cache()
{
	global $db;

	$catinfo = array();

	$getcats = $db->query("SELECT catid, title, parent, haslinks, private, options FROM " . TABLE_PREFIX . "links_categories ORDER BY displayorder ASC, haslinks");
	while ($categories = $db->fetch_array($getcats))
	{
		$catinfo[] = $categories;
	}

	$categoryinfo = array();

	if ($catinfo = construct_directories($catinfo, 0, -1))
	{
		foreach ($catinfo AS $cats)
		{
			$categoryinfo["$cats[catid]"] = $cats;
		}
	}

	$db->free_result($getcats);
	build_datastore('links_d_cache', serialize($categoryinfo));
	unset($categories, $catinfo, $mcats);
}

// ########################### Make Cat Select Field #########################
function print_dir_select($selectedid = 0, $disablemaincats = true, $hideclosed = false)
{
	global $db, $linksperms, $directorycache;

	if (!empty($directorycache))
	{
		foreach ($directorycache as $cats)
		{
			if ($cats['private'] AND !$linksperms['canviewprivatedirs'])
			{
				continue;
			}

			$title = stripslashes($cats['title']);
	    $dashes = str_repeat(' &nbsp; &nbsp; ', $cats['level'] - 1);
			$selected = '';
			if ($selectedid == $cats['catid'])
			{
				$selected = 'selected="selected"';
				$class = 'fjsel';
			}
			elseif ($cats['level'] <= 4)
			{
				$class = 'fjdpth' . $cats['level'];
			}
			else
			{
				$class = 'fjdpth';
			}
			if (!$cats['haslinks'] AND $disablemaincats)
			{
				if ($options)
				{
					$endgroup = true;
					$options .= '</optgroup>';
				}
				$options .= '<optgroup label="&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $dashes . '' . $title . '">';
			}
			else
			{
				if ($hideclosed)
				{
					$diropts = construct_dir_opts($cats['catid'], $cats['options']);
					if (!$diropts['open_for_links'])
					{
						continue;
					}
				}
				$options .= '<option class="' . $class . '" value="' . $cats['catid'] . '" ' . $selected . '>' . $dashes . '' . $title . '</option>';
			}
		}
		if ($endgroup)
		{
			$options .= '</optgroup>';
		}
		unset($cats, $catinfo);
	}
	return $options;
}

// ####################### Construct Private Directories #######################
function fetch_private_directories()
{
	global $directorycache;

	$privcatids = array();
	foreach ($directorycache as $cats)
	{
		if ($cats['private'])
		{
			$privcatids[] = $cats['catid'];
		}
	}
	$privcats = implode(',', $privcatids);

	return $privcats;
}

// ########################### Find Private Directories #######################
function check_directory_permissions($dirid)
{
	global $$linksperms, $vbphrase;
	if ($linksperms['canviewprivatedirs'])
	{
		$privcats = fetch_private_directories();

		if (in_array($dirid, array($privcats)))
		{
			print_no_permission();
		}
	}
}

// ############################ Directory Jump #################################
function print_directory_jump($dcatid = 0)
{
	global $catid, $vba_options, $_REQUEST, $vbphrase, $stylevar, $gobutton;

	if ($vba_options['links_enable_dirjump'])
	{
		switch ($_REQUEST['do'])
		{
			case 'favorites':
				break;
			case 'subscriptions':
				break;
			case 'newlinks':
				break;
			case 'poplinks':
				break;
			case 'search':
				break;
		}
	
		$action = $_REQUEST['do'];

		if ($_REQUEST['do'] == 'searchresults')
		{
			$action = 'search';
		}

		$doselect["$action"] = 'class="fjsel" selected="selected"';
	
		$options = print_dir_select($dcatid, false);
	
		eval('$directoryjump = "' . fetch_template('adv_links_directoryjump') . '";');
		
		return $directoryjump;
	}
}

// ################# Construct the navbits for browselinks ######################
function construct_dir_navbits($parentlist)
{
	global $directorycache, $navbits;

	foreach (array_reverse(explode(',', $parentlist)) AS $key => $parent)
	{
		foreach ($directorycache AS $cats)
		{
			if ($parent == $cats['catid'])
			{
				$navbits["browselinks.php?$session[sessionurl]c=$cats[catid]"] = stripslashes($cats['title']);
			}
		}
	}
	unset($parentlist);
	return $navbits;
}

// ########## Adv Sorting URL (used for sorting on showlink.php ###############
function construct_adv_sort_url($extra = '')
{
	global $_REQUEST;

	if ($_REQUEST['c'])
	{
		$_REQUEST['catid'] = $_REQUEST['c'];
	}

	if (in_array($_REQUEST['do'], array('favorites', 'poplinks', 'newlinks', 'subscriptions', 'member')))
	{
		$adv_sorturl = '&amp;catid=' . $_REQUEST['do'];
	}
	elseif ($_REQUEST['do'] == 'searchresults')
	{
		if ($extra)
		{
			$_REQUEST['searchid'] = $extra;
		}
		$adv_sorturl = '&amp;catid=searchresults';
	}
	else
	{
		$adv_sorturl = '&amp;catid=' . $_REQUEST['catid'];
	}

	if ($_REQUEST['orderby'])
	{
		$adv_sorturl .= '&amp;orderby=' . $_REQUEST['orderby'];
	}
	if ($_REQUEST['direction'])
	{
		$adv_sorturl .= '&amp;direction=' . $_REQUEST['direction'];
	}
	if (!empty($_REQUEST['linkuserid']))
	{
		$adv_sorturl .= '&amp;linkuserid=' . $_REQUEST['linkuserid'];
	}
	if ($_REQUEST['searchid'])
	{
		$adv_sorturl .= '&amp;searchid=' . $_REQUEST['searchid'];
	}
	if ($_REQUEST['page'])
	{
		$adv_sorturl .= '&amp;page=' . $_REQUEST['page'];
	}

	return $adv_sorturl;
}

// ###################### Initial Update Counters Function ##################
function update_count($catid = 0, $linkcounters = true, $postcounters = true, $llcounters = true)
{
	global $db;

	if ($catid)
	{
		$catquery = "WHERE catid = '$catid'";
	}

	$getdirs = $db->query("SELECT catid FROM " . TABLE_PREFIX . "links_categories $catquery ORDER BY displayorder ASC, haslinks");
	while ($dirs = $db->fetch_array($getdirs))
	{
		if ($llcounters)
		{
			$llfields = ', name, dateline, username, userid';
		}

		$linkids = array();

		$getlinks = $db->query("SELECT linkid $llfields FROM " . TABLE_PREFIX . "links WHERE catid = '$dirs[catid]' AND suspended = 0 AND valid = 1 ORDER BY dateline DESC");
		$linkcount = $db->num_rows($getlinks);
		$counter = 0;
		while ($links = $db->fetch_array($getlinks))
		{
			$counter++;
			if ($counter == 1 AND $llcounters)
			{
				$dirs['lastlinkid'] = $links['linkid'];
				$dirs['lastlinkdate'] = $links['dateline'];
				$dirs['lastlinkuser'] = $links['username'];
				$dirs['lastlinkname'] = $links['name'];
				$dirs['lastlinkuserid'] = $links['userid'];
			}
			$linksids[] = $links['linkid'];		
		}
		$db->free_result($getlinks);
		unset($links);

		$dirs['linkcount'] = $linkcount;

		if (!empty($linksids) AND $postcounters)
		{
			$linkids = implode(',', $linksids);
			$postids = array();

			$getposts = $db->query("SELECT postid FROM " . TABLE_PREFIX . "links_posts WHERE linkid IN ($linkids) AND visible = 1");
			$postcount = $db->num_rows($getposts);
			while ($posts = $db->fetch_array($getposts))
			{
				$postids[] = $posts['postid'];
			}
			$dirs['pcount'] = $postcount;
			unset($linkids, $linksids);
		}
		else
		{
			$dirs['pcount'] = 0;
		}

		$db->query_write("UPDATE " . TABLE_PREFIX . "links_categories SET " . iif($linkcounters, "linkcount = '$dirs[linkcount]'") . "" . iif($postcounters, "" . iif($linkcounters, ',') . "postcount = '$dirs[pcount]' ") . " " . iif($llcounters, "" . iif($postcounters OR $linkcounters, ',') . "lastlinkid = '$dirs[lastlinkid]', lastupdated = '$dirs[lastlinkdate]', lastlinktitle = '" . addslashes($dirs['lastlinkname']) . "', lastposter = '" . addslashes($dirs['lastlinkuser']) . "', lastuserid = '$dirs[lastlinkuserid]'") . " WHERE catid = '$dirs[catid]' AND haslinks = 1");
	}
}

// ############### Rebuild Directory Info (Update Counters) ######################
function rebuild_dir_info($dirinfo, $cat = 0)
{
	global $db, $donearray;

	if (empty($donearray))
	{
		$donearray = array();
	}

	foreach ($dirinfo AS $info => $dirs)
	{
		if (($dirs['parent'] == $cat OR $dirs['catid'] == $cat) AND !in_array($dirs['catid'], $donearray))
		{
			$donearray[] = $dirs['catid'];

			if ($subcat = rebuild_dir_info($dirinfo, $dirs['catid']))
			{
				$directoryarray = array_merge($directoryarray, $subcat);
			}

			$directoryarray[] = $dirs;
		}
	}
	return $directoryarray;
}

// ######################### Create Custom Fields #######################
function construct_custom_fieldbits($linkinfo, $custominfo = '', $editing = false, $admin = false, $makearray = false)
{
	global $db, $vbphrase;

	if (empty($custominfo))
	{
		$custominfo = array();
		$customfields = $db->query("SELECT * FROM " . TABLE_PREFIX . "links_customfields ORDER BY displayorder");
		while ($field = $db->fetch_array($customfields))
		{
			$custominfo[] = $field;
		}
		$db->free_result($customfields);
		unset($field);
	}
	
	if (!empty($custominfo))
	{
		foreach ($custominfo AS $field)
		{
			$fieldname = 'field' . $field['fieldid'];
			$fieldid = 'field' . $field['fieldid'] . iif($makearray, '[' . $linkinfo['linkid'] . ']');
			if ($field['options'])
			{
				$field['options'] = explode("\n", $field['options']);
			}
	
			switch($field['type'])
			{
				case 'textarea':
					$inputbox = '<textarea class="bginput" cols="40" name="' . $fieldid . '" rows="6">' . htmlspecialchars($linkinfo["$fieldname"]) . '</textarea>';
					break;
	
				case 'select':
					$linkinfo["$fieldname"] = htmlspecialchars($linkinfo["$fieldname"]);
					$inputbox = '<select name="' . $fieldid . '">';
					$inputbox .= '<option value="">' . $vbphrase['please_select_one'] . '</option>';
					foreach ($field['options'] AS $option)
					{
						$inputbox .= '<option ' . iif($linkinfo["$fieldname"] == $option, 'selected="selected"') . ' value="' . $option . '">' . $option . '</option>';
					}
					$inputbox .= '</select>';
					break;
	
				case 'radio':

					$linkinfo["$fieldname"] = htmlspecialchars($linkinfo["$fieldname"]);

					foreach ($field['options'] AS $key => $option)
					{
						$option = trim($option);
						$inputbox .= '<label for="' . $fieldid . '_' . $key . '"><input id="' . $fieldid . '_' . $key . '" name="' . $fieldid . '" ' . iif($linkinfo["$fieldname"] == $option, 'checked="checked"') . ' type="radio" value="' . $option . '">' . $option . '</label>';
					}
					break;
	
				case 'checkbox':
	
					if (!is_array($linkinfo["$fieldname"]) AND !$editing)
					{
						$linkinfo["$fieldname"] = array();
					}
					if ($editing)
					{
						$linkinfo["$fieldname"] = explode(', ', $linkinfo["$fieldname"]);
					}

					$optarray = array();
					foreach ($linkinfo["$fieldname"] AS $okey => $ovalue)
					{
						$optarray[] = htmlspecialchars($ovalue);
					}
	
					foreach ($field['options'] AS $key => $option)
					{
						$option = trim($option);
						$inputbox .= '<label for="' . $fieldid . '_' . $key . '"><input id="' . $fieldid . '_' . $key . '" name="' . $fieldid . '[]" ' . iif(in_array($option, $optarray), 'checked="checked"') . ' type="checkbox" value="' . $option . '">' . $option . '</label><br />'; 
					}
					break;
	
				default:
					$inputbox = '<input class="bginput" name="' . $fieldid . '" size="35" value="' . htmlspecialchars($linkinfo["$fieldname"]) . '" />';
					
			}
	
			if ($admin)
			{
				print_label_row($field['title'], $inputbox);
			}
			else
			{
				eval('$cfbits .= "' . fetch_template('adv_links_addlink_custombits') . '";');
			}
			unset($inputbox);
		}
	}
	return $cfbits;
}

// ######################## Sort custom fields to insert into the db ####################
function construct_customfields_sql($linkid, $add = true, $makearray = false)
{
	global $db, $_POST;

	$cfields = array();
	$customfields = $db->query("SELECT * FROM " . TABLE_PREFIX . "links_customfields");
	while ($custom = $db->fetch_array($customfields))
	{
		$cfields["$custom[fieldid]"] = $custom;
	}

	if (!$add AND !$check = $db->query_first("SELECT lid FROM " . TABLE_PREFIX . "links_customfields_entries WHERE lid = '$linkid'"))
	{
		$add = true;
	}

	if ($cfields)
	{
		foreach ($cfields AS $field => $values)
		{
			$thisfield = 'field' . $field;

			if ($makearray)
			{
				$fieldname = $_POST["$thisfield"]["$linkid"];
			}
			else
			{
				$fieldname = $_POST["$thisfield"];
			}
			if (strlen($fieldname) > $values['maxlength'] AND $values['maxlength'])
			{
				$fieldname = substr($fieldname, 0, $values['maxlength']);
			}

			if (is_array($fieldname))
			{
				$fieldname = implode(', ', $fieldname);
			}

			if ($add)
			{
				$insert['fields'] .= ',' . $thisfield;
				$insert['values'] .= ', \'' . addslashes($fieldname) . '\'';
			}
			else
			{
				
				$insert['fields'] .= ', ' . $thisfield . ' = \'' . addslashes($fieldname) . '\'';
			}
		}
	}

	if ($add)
	{
		$db->query_write("INSERT INTO " . TABLE_PREFIX . "links_customfields_entries (lid $insert[fields]) VALUES ($linkid $insert[values])");
	}
	else
	{
		if (!empty($insert))
		{
			$insert['fields'] = substr($insert['fields'], 1);
			$db->query_write("UPDATE " . TABLE_PREFIX . "links_customfields_entries SET $insert[fields] WHERE lid = '$linkid'");
		}
	}
}	


// ###################### Directory Options #######################
function construct_dir_opts($dirid, $dirint)
{
	global $directoryopts;

	foreach ($directoryopts AS $option => $value)
	{
		$diropts["$option"] = 0;
		if($dirint & $value)
		{
			$diropts["$option"] = 1;
		}
	}
	return $diropts;
}

// ############################# Subscribed Posts #########################
function send_subscribed_posts($linkid, $moderation = false, $userid = '', $username = '', $message = '')
{
	global $db, $vba_options, $vbulletin, $post;

	if ($vba_options['links_allowsubscribe'])
	{
		$link = $db->query_first("
				SELECT links.linkid, name, posts.dateline, categories.title
				FROM " . TABLE_PREFIX . "links_posts AS posts
				INNER JOIN " . TABLE_PREFIX . "links AS links USING (linkid)
				INNER JOIN " . TABLE_PREFIX . "links_categories AS categories USING (catid)
				WHERE links.linkid = '$linkid' ORDER BY dateline DESC LIMIT 1
		");

		if (!$moderation)
		{
			$userid = $vbulletin->userinfo['userid'];
		}
		else
		{
			$post['message'] = $message;
			$vbulletin->userinfo['username'] = $username;
		}

		$linkname = stripslashes($link['name']);
		$directoryname = stripslashes($link['title']);

		$subscriptions = $db->query("
				SELECT subscriptions.userid, username, email
				FROM " . TABLE_PREFIX . "links_subscribelink AS subscriptions
				INNER JOIN " . TABLE_PREFIX . "user AS user USING (userid)
				WHERE linkid = '$linkid' AND user.lastactivity > '$link[dateline]' AND subscriptions.userid != '$userid'
		");
		while ($subscription = $db->fetch_array($subscriptions))
		{
			$username = $subscription['username'];
			eval(fetch_email_phrases('adv_links_subscribe_link', 0));
			vbmail($subscription['email'], $subject, $message);
		}
	}
}

// ######################## Function to Validate New Links ########################
function validate_new_links($validatelink)
{
	global $db, $vba_options, $email, $dateline, $username, $userid, $name, $desc, $linkurl, $catid, $keywords, $views, $sendmail, $validatelink, $notes;


	if (is_array($validatelink))
	{
		foreach ($validatelink AS $key => $val)
		{
			if ($validatelink["$key"] == 2)
			{
				delete_links($key);

				if ($sendmail["$key"] AND !empty($email["$key"]))
				{
					$mailusername = $username["$key"];
					$linktitle = $name["$key"];
					$linkid = $key;
					$hometitle = $vbulletin->options['hometitle'];
					$linksurl = $vba_options['links_homeurl'];

					eval(fetch_email_phrases('adv_links_deletion', 0));
					
					vbmail($email["$key"], $subject, $message);
				}
			}
			if ($validatelink["$key"] == 1)
			{
				$db->query_write("UPDATE " . TABLE_PREFIX . "links SET name = '" . addslashes(htmlspecialchars($name["$key"])) . "', description = '" . addslashes(htmlspecialchars($desc["$key"])) . "', url = '" . addslashes(htmlspecialchars($linkurl["$key"])) . "', keywords = '" . addslashes(htmlspecialchars($keywords["$key"])) . "', views = '$views[$key]', catid = '$catid[$key]', notes = '" . addslashes($notes["$key"]) . "', valid = 1 WHERE linkid = '$key'");

				construct_customfields_sql($key, false, true);

				if ($sendmail["$key"] AND !empty($email["$key"]))
				{
					$mailusername = $username["$key"];
					$linktitle = $name["$key"];
					$linkid = $key;
					$hometitle = $vbulletin->options['hometitle'];
					$linksurl = $vba_options['links_homeurl'];

					eval(fetch_email_phrases('adv_links_validation', 0));
					
					vbmail($email["$key"], $subject, $message);
				}

				$cat = $db->query_first("SELECT lastupdated FROM " . TABLE_PREFIX . "links_categories WHERE catid = '$catid[$key]'");

				if ($dateline["$key"] > $cat['lastupdated'])
				{
					$extrafields = ", lastlinkid = '$key', lastposter = '" . addslashes($username["$key"]) . "', lastlinktitle = '" . addslashes(htmlspecialchars($name["$key"])) . "', lastuserid = '$userid[$key]', lastupdated = '$dateline[$key]'";
				}

				$db->query_write("UPDATE " . TABLE_PREFIX . "links_categories SET linkcount = linkcount+1 $extrafields WHERE catid = '$catid[$key]'");

			}
		}
	}
}

// ####################### Validate New Posts ######################
function validate_new_posts()
{
	global $db, $vba_options, $title, $message, $validatepost, $catid, $linkid, $userid, $username, $dateline;

	if (is_array($validatepost))
	{
		foreach ($validatepost AS $key => $val)
		{
			if ($validatepost["$key"] == 2)
			{
				$db->query_write("DELETE FROM " . TABLE_PREFIX . "links_posts WHERE postid = '$key'");

			}
			if ($validatepost["$key"] == 1)
			{

				$db->query_write("UPDATE " . TABLE_PREFIX . "links_posts SET title = '" . addslashes(htmlspecialchars($title["$key"])) . "', pagetext = '" . addslashes($message["$key"]) . "', visible = '1' WHERE postid = '$key'");

				// Update link info
				$link = $db->query_first("SELECT lastpostdateline FROM " . TABLE_PREFIX . "links WHERE linkid = '$linkid[$key]'");

				if ($link['lastpostdateline'] < $dateline["$key"])
				{
					$lastpostquery = ", lastpostuserid = '$userid[$key]', lastpostusername = '" . addslashes($username["$key"]) . "', lastpostdateline = '$dateline[$key]'";
				}

				$db->query_write("UPDATE " . TABLE_PREFIX . "links SET posts = posts+1 $lastpostquery WHERE linkid = '$linkid[$key]'");

				// Send email to subscribed users
				send_subscribed_posts($linkid["$key"], true, $userid["$key"], $username["$key"], $message["$key"]);

				// Update directory info
				$db->query_write("UPDATE " . TABLE_PREFIX . "links_categories SET postcount = postcount+1 WHERE catid = '$catid[$key]'");
		
				// Update user post counts
				if ($vba_options['links_update_postcount'])
				{
					$db->query_write("UPDATE " . TABLE_PREFIX . "user SET posts = posts+1 WHERE userid = '$userid[$key]'");
				}
			}
		}
	}
}

// ######################## Construct Replacement Array #######################
if (!function_exists('construct_replacement_array'))
{
	function construct_replacement_array($optreplace, $replacearray)
	{
		global $vbulletin;
		if (!empty($optreplace))
		{
			foreach ($optreplace AS $filename)
			{
				if (trim($filename))
				{
					$replacearray['find'][] = '"' . $filename;
					$replacearray['replace'][] = '"' . $vbulletin->options['bburl'] . '/' . $filename;
				}
			}
		}
		return array_merge($optreplace, $replacearray);
	}
}

?>