<?php
// ++=========================================================================++
// || vBadvanced Links Directory v1.0.1 (vB 3.5) - 17185
// ||  2003-2004 vBadvanced.com & PlurPlanet, LLC - All Rights Reserved
// || This file may not be redistributed in whole or significant part.
// || http://vbadvanced.com
// || Downloaded 14:49, Wed Oct 5th 2005
// || 3105590_051718507648
// ++ ========================================================================++

error_reporting(E_ALL & ~E_NOTICE);
define('NO_REGISTER_GLOBALS', 1);
define('THIS_SCRIPT', 'browselinks');

$globaltemplates = array();

$specialtemplates = array(
	'links_mod_cache'
);

$actiontemplates = array(
	'browselinks' => array(
		'ADV_LINKS_BROWSELINKS',
		'adv_links_letter',
		'adv_links_letter_selected',
		'adv_links_nodisplay',
		'adv_links_directorybit_level1',
		'adv_links_directorybit_level2',
		'adv_links_directorybit_main',
		'forumdisplay_sortarrow',
		'adv_links_linkbit',
		'forumhome_moderator'
	),
	'newlinks' => array(
		'ADV_LINKS_RESULTS',
		'adv_links_linkbit'
	),
	'poplinks' => array(
		'ADV_LINKS_RESULTS',
		'adv_links_linkbit'
	),
	'favorites' => array(
		'ADV_LINKS_BROWSELINKS',
		'adv_links_linkbit',
		'adv_links_letter',
		'adv_links_nodisplay',
		'forumdisplay_sortarrow'
	),
	'subscriptions' => array(
		'ADV_LINKS_BROWSELINKS',
		'adv_links_directorybit_level1',
		'adv_links_directorybit_level2',
		'adv_links_linkbit',
		'adv_links_letter',
		'adv_links_nodisplay',
		'forumdisplay_sortarrow',
		'forumhome_moderator'
	),
	'member' => array(
		'ADV_LINKS_BROWSELINKS',
		'adv_links_linkbit',
		'adv_links_letter',
		'adv_links_nodisplay',
		'forumdisplay_sortarrow'
	)
);

$actiontemplates['none'] = &$actiontemplates['browselinks'];

$phrasegroups = array('forumdisplay');

if ($_REQUEST['catid'] AND $_REQUEST['do'] == 'jump')
{
	switch($_REQUEST['catid'])
	{
		case 'home':
			$redirect = 'index.php?' . $session['sessionurl'];
			break;
		case 'favorites':
			$redirect = 'browselinks.php?' . $session['sessionurl'] . 'do=favorites';
			break;
		case 'subscriptions':
			$redirect = 'browselinks.php?' . $session['sessionurl'] . 'do=subscriptions';
			break;
		case 'search':
			$redirect = 'search.php?' . $session['sessionurl'];
			break;
		case 'whatsnew':
			$redirect = 'browselinks.php?' . $session['sessionurl'] . 'do=newlinks';
			break;
		case 'whatspop':
			$redirect = 'browselinks.php?' . $session['sessionurl'] . 'do=poplinks';
			break;
		default:
			$catid = intval($_REQUEST['catid']);
	}
}

require_once('./links_global.php');

if (empty($_REQUEST['do']) OR $_REQUEST['do'] == 'jump')
{
	$_REQUEST['do'] = 'browselinks';
}

$pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_INT);
$userid = $vbulletin->input->clean_gpc('r', 'userid', TYPE_INT);
$linkuserid = $vbulletin->input->clean_gpc('r', 'linkuserid', TYPE_INT);
$orderby = $vbulletin->input->clean_gpc('r', 'orderby', TYPE_NOHTML);
$direction = $vbulletin->input->clean_gpc('r', 'direction', TYPE_NOHTML);
$ltr = $vbulletin->input->clean_gpc('r', 'ltr', TYPE_NOHTML);
$pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_NOHTML);
$pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_NOHTML);

if (!$linksperms['canviewlinks'])
{
	$nolinksdisplay = true;
}

$show['directoryhead'] = true;
$show['directory_tools'] = false;

switch ($_REQUEST['do']) 
{
	// New Links
	case 'newlinks':

		$doorderby = 'dateline DESC, linkid';
		$limit = $vba_options['links_newlinklimit'];
		$direction = 'DESC';
		$catinfo['title'] = construct_phrase($vbphrase['newest_x_links'], $vba_options['links_newlinklimit']);
		$navname = $vbphrase['whats_new'];
		$returnto = 'newlinks';
		break;
	
	// Popular Links
	case 'poplinks':

		switch ($orderby)
		{
			case posts:
				$catinfo['title'] = $vbphrase['top_x_replied_to_links'];
				$doorderby = 'posts';
				break;
			case 'rating':
				$votequery = 'IF(votenum >= ' . $vbulletin->options['showvotes'] . ', votenum, 0) AS votenum, IF(votenum >= ' . $vbulletin->options['showvotes'] . ' AND votenum> 0, votetotal / votenum, 0) AS voteavg,';
				$doorderby = 'voteavg DESC, votenum';
				$catinfo['title'] = $vbphrase['top_x_rated_links'];
				break;
			default:
				$doorderby = 'views';
				$orderby = 'views';
				$catinfo['title'] = $vbphrase['top_x_visited_links'];
		}

		$orderbysel[$orderby] = 'selected="selected"';

		$limit = $vba_options['links_poplinklimit'];
		$direction = 'DESC';
		$navname = $vbphrase['whats_popular'];
		$returnto = 'poplinks';
		$show['poplinks'] = true;
		break;

	// Favorites
	case 'favorites':
		if (!$vbulletin->userinfo['userid'])
		{
			print_no_permission();
		}
		$catinfo['title'] = $vbphrase['my_favorites'];
		$navname = $vbphrase['my_favorites'];
		$catid = 'favorites';
		$returnto = 'favorites';
		$show['dir_search'] = true;
		break;

	// Subscriptions
	case 'subscriptions':
		if (!$vbulletin->userinfo['userid'])
		{
			print_no_permission();
		}
		$catinfo['title'] = $vbphrase['my_subscriptions'];
		$navname = $vbphrase['my_subscriptions'];
		$catid = 'subscriptions';
		$returnto = 'subscriptions';

		$getsubdirs = $db->query("
				SELECT categories.*, subscribedir.*
				FROM " . TABLE_PREFIX . "links_categories AS categories
				INNER JOIN " . TABLE_PREFIX . "links_subscribedir AS subscribedir ON (categories.catid = subscribedir.dirid)
				ORDER BY displayorder
		");
		if ($db->num_rows($getsubdirs))
		{
			$show['subdirs'] = true;
			$vbphrase['sub_directories'] = $vbphrase['directories'];
			$dirinfo = array();
			while ($subdirs = $db->fetch_array($getsubdirs))
			{
				$dirinfo[] = $subdirs;
			}
			$show['subscribe_options'] = true;
			$subdirbits = print_directories(0, $dirinfo, true);
		}

		break;

	case 'member':
		if (!isset($linkuserid))
		{
			eval(standard_error(fetch_error('noid', $vbphrase['user'])));
		}
		$condition = 'links.userid = \'' . $linkuserid . '\' AND ';
		$show['directory_tools'] = false;
		$show['dir_search'] = false;
		$returnto = 'member';
		break;

	// Browse Links
	default:

		// Join subscribedir if needed
		if ($_REQUEST['do'] == 'browselinks' AND $vba_options['links_allowsubscribe'] AND $vbulletin->userinfo['userid'])
		{
			$subdirfields = ', NOT ISNULL(subscribedir.dirid) AS subdirid';
			$subdirjoin = 'LEFT JOIN ' . TABLE_PREFIX . 'links_subscribedir AS subscribedir ON (links_categories.catid = subscribedir.dirid AND subscribedir.userid = ' . $vbulletin->userinfo['userid'] . ')';
		}

		// Get category info
		$catinfo = $db->query_first("
				SELECT catid, title, parentlist, options 
				$subdirfields
				FROM " . TABLE_PREFIX . "links_categories AS links_categories
				$subdirjoin
				WHERE catid = '$catid'
		");
		if (!$catinfo['catid'])
		{
			eval(standard_error(fetch_error('noid', $vbphrase['directory'])));
		}

		if ($catinfo['subdirid'])
		{
			$show['unsubscribe_dir'] = true;
		}

		$condition = 'links.catid = \'' . $catid . '\' AND ';
		$stickyorder = 'sticky DESC,';
		$show['directoryhead'] = false;
		$show['directory_tools'] = true;
		$show['dir_search'] = true;

		if ($subdirbits = print_directories($catid))
		{
			$show['subdirs'] = true;
		}

		check_directory_permissions($catid);

		$returnto = 'cat';

		break;
}

// Exclude private directories
if ($_REQUEST['do'] != 'browselinks' AND !$linksperms['canviewprivatedirs'])
{
	$privdirs = fetch_private_directories();
	if ($privdirs)
	{
		$condition .= 'links.catid NOT IN(' . $privdirs . ') AND ';
	}
}

$adv_sorturl = construct_adv_sort_url();

if (in_array($_REQUEST['do'], array('browselinks', 'favorites', 'subscriptions', 'member')))
{
	$doorderby = construct_orderby();
	if ($doorderby == $vba_options['links_deforder'])
	{
		$orderby = $vba_options['links_deforder'];
	}

	if ($orderby == 'rating')
	{
		$votequery = 'IF(votenum >= ' . $vbulletin->options['showvotes'] . ', votenum, 0) AS votenum, IF(votenum >= ' . $vbulletin->options['showvotes'] . ' AND votenum> 0, votetotal / votenum, 0) AS voteavg,';
	}

	if ($doorderby == 'name' AND !$direction)
	{
		$direction = 'asc';
	}

	if ($cutoffdate AND $cutoffdate != -1)
	{
		$condition .= ' links.dateline > ' . (time() - ($cutoffdate * 86400)) . ' AND';
	}

	if (!$cutoffdate OR $cutoffdate == -1)
	{
		$cutoffdate = 'all';
	}

	$datecutsel = array();
	$datecutsel[$cutoffdate] = 'selected="selected"';

	$ordersel = array();
	$ordersel[$orderby] = 'selected="selected"';

	$item = $vbphrase['links'];

	// Letterbits
	$letter = '#';
	if ($ltr == 'nonalpha')
	{
		$letterselected = 1;
	}
	$letterurl = 'browselinks.php?' . $session['sessionurl'] . 'do=' . $_REQUEST['do'] . '&amp;catid=' . $catid . '&amp;ltr=nonalpha&amp;linkuserid=' . $linkuserid . '';
	eval('$letterbits = "' . fetch_template('adv_links_letter') . '";');

	// The rest of the alphabet
	$alphabet = range('A', 'Z'); 
	foreach($alphabet as $letter)
	{ 
		$letterselected = 0;
	  if ($ltr == $letter)
		{
			$letterselected = 1;
		}
		$letterurl = 'browselinks.php?' . $session['sessionurl'] . 'do=' . $_REQUEST['do'] . '&amp;catid=' . $catid . '&amp;ltr=' . $letter . '&amp;linkuserid=' . $linkuserid;
		eval('$letterbits .= "' . fetch_template('adv_links_letter') . '";');
	}

	if ($ltr AND ($ltr == 'nonalpha' OR in_array($ltr, $alphabet))) 
	{
		if ($ltr == 'nonalpha') 
		{
			$condition .= 'name NOT REGEXP("^[a-zA-Z]") AND';
		}
		else
		{
			$condition .= 'name LIKE(\'' . $ltr . '%\') AND';
		}
	}

	if ($direction == 'asc')
	{
		$oppositesort = 'desc';
	}
	else
	{
		$direction = 'desc';
		$oppositesort = 'asc';
	}

	$dirsel[$direction] = 'selected="selected"';

	$sorturl = 'browselinks.php?' . $session['sessionurl'] . 'do=' . $_REQUEST['do'] . '&amp;c=' . $catid . '&amp;orderby=' . $orderby . '&amp;direction=' . $oppositesort;
  eval('$arrow[$orderby] = "' . fetch_template('forumdisplay_sortarrow') . '";');

	if ($linksperms['canviewlinks'] AND !$nolinksdisplay)
	{
		
		switch ($_REQUEST['do'])
		{
			case 'favorites':
				$countlinks = $db->query_first("
						SELECT COUNT(*) AS count 
						FROM " . TABLE_PREFIX . "links_favorites AS favorites 
						LEFT JOIN " . TABLE_PREFIX . "links AS links USING (linkid) 
						WHERE favorites.userid = '" . $vbulletin->userinfo['userid'] . "' AND $condition suspended = 0 AND valid = 1
				");
				break;

			case 'subscriptions':
				$countlinks = $db->query_first("
						SELECT COUNT(*) AS count 
						FROM " . TABLE_PREFIX . "links_subscribelink AS subscribelink
						LEFT JOIN " . TABLE_PREFIX . "links AS links USING (linkid) 
						WHERE subscribelink.userid = '" . $vbulletin->userinfo['userid'] . "' AND $condition suspended = 0 AND valid = 1
				");
				break;

			default:
			  $countlinks = $db->query_first("SELECT COUNT(*) AS count FROM " . TABLE_PREFIX . "links AS links WHERE suspended = 0 AND $condition valid = 1");
		}
	}

	if ($countlinks['count'] == 0)
	{
		$nolinksdisplay = true;
	}
	else
	{
		// Work out pages & limits
		if (!intval($pagenumber))
		{
			$pagenumber = 1;
		}
		$perpage = intval($vba_options['links_perpage']);
		$minlimit = intval(($pagenumber - 1) * $perpage + 1);
		$maxlimit = intval($pagenumber * $perpage);
		
		if ($maxlimit > $countlinks['count'])
		{
			$maxlimit = $countlinks['count'];
			if ($minlimit > $countlinks['count'])
			{
			  $minlimit = $countlinks['count'] - $perpage;
			}
		}
		if ($minlimit <= 0)
		{
		  $minlimit = 1;
		}
		$limit = ($minlimit - 1) . ',' . $perpage;
		$pagenav = construct_page_nav($pagenumber, $perpage, $countlinks['count'], 'browselinks.php?' . $session['sessionurl'] . 'do=' . $_REQUEST['do'] . $adv_sorturl);
	}		
}

if (!$nolinksdisplay)
{
	switch($_REQUEST['do'])
	{
		case 'favorites':
			$getids = $db->query("
					SELECT $votequery links.linkid
					FROM " . TABLE_PREFIX . "links_favorites AS favorites
					INNER JOIN " . TABLE_PREFIX . "links AS links USING (linkid)
					" . iif($orderby == 'directory', 
					'LEFT JOIN ' . TABLE_PREFIX . 'links_categories AS links_categories ON (links.catid = links_categories.catid)') . "
					WHERE suspended = 0 AND valid = 1 AND $condition favorites.userid = '" . $vbulletin->userinfo['userid'] . "'
					ORDER BY $doorderby $direction
					LIMIT " . ($minlimit - 1) . ", $perpage
			");
			
			break;

		case 'subscriptions':
			$getids = $db->query("
					SELECT $votequery links.linkid
					FROM " . TABLE_PREFIX . "links_subscribelink AS subscribelink
					INNER JOIN " . TABLE_PREFIX . "links AS links USING (linkid)
					" . iif($orderby == 'directory', 
					'LEFT JOIN ' . TABLE_PREFIX . 'links_categories AS links_categories ON (links.catid = links_categories.catid)') . "
					WHERE $condition suspended = 0 AND valid = 1 AND $condition subscribelink.userid = '" . $vbulletin->userinfo['userid'] . "'
					ORDER BY $doorderby $direction
					LIMIT " . ($minlimit - 1) . ", $perpage
			");

			break;

		default:
			$getids = $db->query("
					SELECT $votequery links.linkid
					FROM " . TABLE_PREFIX . "links AS links
					" . iif($orderby == 'directory', 
					'LEFT JOIN ' . TABLE_PREFIX . 'links_categories AS links_categories ON (links.catid = links_categories.catid)') . "
					WHERE suspended = 0 AND $condition valid = 1 
					ORDER BY $stickyorder $doorderby $direction
					LIMIT $limit
			");

	}		
	$linkids = array();
	while ($linkid = $db->fetch_array($getids))
	{
		$linkids[] = $linkid['linkid'];
	}

	if (!empty($linkids))
	{
		$linkids = implode(',', $linkids);

		// Subscribed links
		if ($vba_options['links_allowsubscribe'] AND $vbulletin->userinfo['userid'] AND $_REQUEST['do'] != 'subscriptions')
		{
			$subfields = ', NOT ISNULL(subscribelink.linkid) AS subid';
			$subjoin = 'LEFT JOIN ' . TABLE_PREFIX . 'links_subscribelink AS subscribelink ON (links.linkid = subscribelink.linkid AND ' . $vbulletin->userinfo['userid'] . ' = subscribelink.userid)';
		}
	
		// Get post info if user has permission
		if ($vba_options['links_allowreplies'] AND $linksperms['canviewlinkreplies'])
		{
			$postfields = ', posts, lastpostdateline, lastpostuserid, lastpostusername';
		}
	
		// Join favorites if userid
		if ($vbulletin->userinfo['userid'] AND $vba_options['links_allowfav'] AND $_REQUEST['do'] != 'favorites')
		{
			$favfields = ', NOT ISNULL(favorites.linkid) AS favid';
			$favjoin = 'LEFT JOIN ' . TABLE_PREFIX . 'links_favorites AS favorites ON (favorites.linkid = links.linkid AND favorites.userid = ' . $vbulletin->userinfo['userid'] . ')';
		}

		if ($_REQUEST['do'] != 'browselinks')
		{
			$catfields = ', links_categories.title, options, parentlist, parent';
			$catjoin = 'INNER JOIN ' . TABLE_PREFIX . 'links_categories AS links_categories ON (links.catid = links_categories.catid)';
		}

		// Get Links
		$getlinks = $db->query("
					SELECT $votequery links.linkid, name, links.description, url, links.catid, views, posts, username, links.userid, dateline, sticky, open, votenum, votetotal $catfields $favfields $subfields $postfields, customfields.*
					FROM " . TABLE_PREFIX . "links AS links
					LEFT JOIN " . TABLE_PREFIX . "links_customfields_entries AS customfields ON (links.linkid = customfields.lid)
					$catjoin
					$favjoin
					$subjoin
					WHERE links.linkid IN($linkids)
					ORDER BY $stickyorder $doorderby $direction
		");
		
		while ($links = $db->fetch_array($getlinks))
		{
	
			if ($_REQUEST['do'] == 'favorites')
			{
				$links['favid'] = 1;
			}
	
			if ($_REQUEST['do'] == 'subscriptions')
			{
				$links['subid'] = 1;
			}
			$lusername = $links['username'];
			$linkbits .= construct_linkbits($links);
		} 

		if ($_REQUEST['do'] == 'member')
		{
			if (substr($lusername, -1) != 's')
			{ 
				$plurals = $vbphrase['plural_s']; 
			} 

			$catinfo['title'] = construct_phrase($vbphrase['usernames_links'], $lusername, $plurals);
			$navname = $catinfo['title'];
		}

		if ($_REQUEST['do'] == 'browselinks')
		{
			$links_modcache = cache_links_mods();
			$modcount = 0;
			
			foreach (explode(',', $catinfo['parentlist']) AS $parentid)
			{
				if ($links_modcache["$parentid"])
				{
					foreach($links_modcache["$parentid"] AS $moderator)
					{
						if (empty($donemods))
						{
							$donemods = array();
						}
						if (!in_array($moderator['userid'], $donemods))
						{
							$donemods[] = $moderator['userid'];
							$modcount++;
							$comma = '';
							if (!empty($mods))
							{
								$comma = ', ';
							}
							eval('$mods .= "$comma' . fetch_template('forumhome_moderator') . '";');
							$mods = str_replace('"member.php', '"' . $vbulletin->options['bburl'] . '/member.php', $mods);
						}
					}
				}
			}
			$navname = $catinfo['title'];
		}
	
		$db->free_result($getlinks);
		unset($links);
	}
	else
	{
		eval('$linkbits = "' . fetch_template('adv_links_nodisplay') . '";');
	}
}
else
{
	if ($_REQUEST['do'] == 'member')
	{
		$user = $db->query_first("SELECT username FROM " . TABLE_PREFIX . "user WHERE userid = '$linkuserid'");
		if (substr($user['username'], -1) != 's')
		{ 
			$plurals = $vbphrase['plural_s']; 
		} 
		$catinfo['title'] = construct_phrase($vbphrase['usernames_links'], $user['username'], $plurals);
		$navname = $catinfo['title'];
	}

	eval('$linkbits = "' . fetch_template('adv_links_nodisplay') . '";');
}

$directoryjump = print_directory_jump($catid);

if ($_REQUEST['do'] == 'browselinks')
{
	$navbits = construct_dir_navbits($catinfo['parentlist']);
}
else
{
	$navbits[''] = $navname;
}
$navbits = construct_navbits($navbits);
eval('$navbar = "' . fetch_template('navbar') . '";');

$minlimit = number_format($minlimit);
$maxlimit = number_format($maxlimit);
$countlinks['count'] = number_format($countlinks['count']);

if (in_array($_REQUEST['do'], array('browselinks', 'favorites', 'subscriptions', 'member')))
{
	if (defined('VBA_PORTAL'))
	{
		eval('$html = "' . fetch_template('ADV_LINKS_BROWSELINKS') . '";');
		print_portal_output($home, $html);
	}
	else
	{
		eval('print_output("' . fetch_template('ADV_LINKS_BROWSELINKS') . '");');
	}

}
else
{
	if (defined('VBA_PORTAL'))
	{
		eval('$html = "' . fetch_template('ADV_LINKS_RESULTS') . '";');
		print_portal_output($home, $html);
	}
	else
	{
		eval('print_output("' . fetch_template('ADV_LINKS_RESULTS') . '");');
	}
}

?>
