<?php
// ++=========================================================================++
// || vBadvanced Links Directory v1.0.1 (vB 3.5) - 17185
// ||  2003-2004 vBadvanced.com & PlurPlanet, LLC - All Rights Reserved
// || This file may not be redistributed in whole or significant part.
// || http://vbadvanced.com
// || Downloaded 14:49, Wed Oct 5th 2005
// || 3105590_051718507648
// ++ ========================================================================++

error_reporting(E_ALL & ~E_NOTICE);
define('NO_REGISTER_GLOBALS', 1);
define('THIS_SCRIPT', 'linksindex');

$phrasegroups = array();

$globaltemplates = array(
	'ADV_LINKS',
	'adv_links_directorybit_level1',
	'adv_links_directorybit_level2',
	'adv_links_directorybit_main',
	'adv_links_linkbit',
	'forumhome_moderator'
);

$specialtemplates = array(
	'links_mod_cache'
);

require_once('./links_global.php');

// Grabbing the categories here so we can re-use the info for the stats
$catinfo = array();

$getcats = $db->query("
		SELECT catid, title, description, parent, haslinks, parentlist" . iif($linksperms['canviewlinks'],', linkcount, postcount, private, lastlinkid, lastlinktitle, lastposter, lastuserid, lastupdated') . "
		FROM " . TABLE_PREFIX ."links_categories
		ORDER BY displayorder ASC, haslinks
");
while ($categories = $db->fetch_array($getcats))
{
	$catinfo[] = $categories;
}

$db->free_result($getcats);
unset($categories);

$directorybits = print_directories(intval($catid), $catinfo);

if (!$catid)
{
	$show['directoryhead'] = true;
	$show['stats'] = true;
	$returnto = 'index';

	// Stats
	if (is_array($catinfo))
	{
		$dircount = 0;
		$tlinks = 0;
		$tposts = 0;
		foreach ($catinfo AS $count)
		{
			if ($count['private'] AND !$linksperms['canviewprivatedirs'])
			{
				continue;
			}
			$tdirs++;
			$tlinks += $count['linkcount'];
			$tposts += $count['postcount'];
		}
	}
	$totaldirs = number_format($tdirs);
	$totallinks = number_format($tlinks);
	$totalposts = number_format($tposts);

	$tviews = $db->query_first("SELECT SUM(views) AS tviews FROM " . TABLE_PREFIX . "links");
	$totalviews = number_format($tviews['tviews']);

	// Subscribed links
	if ($vba_options['links_allowsubscribe'] AND $vbulletin->userinfo['userid'])
	{
		$subfields = ', NOT ISNULL(subscribelink.linkid) AS subid';
		$subjoin = 'LEFT JOIN ' . TABLE_PREFIX . 'links_subscribelink AS subscribelink ON (links.linkid = subscribelink.linkid AND ' . $vbulletin->userinfo['userid'] . ' = subscribelink.userid)';
	}

	// Get post info if user has permission
	if ($vba_options['links_allowreplies'] AND $linksperms['canviewlinkreplies'])
	{
		$postfields = ', posts, lastpostdateline, lastpostuserid, lastpostusername';
	}

	// Join favorites if userid
	if ($vbulletin->userinfo['userid'] AND $vba_options['links_allowfav'])
	{
		$favfields = ', NOT ISNULL(favorites.linkid) AS favid';
		$favjoin = 'LEFT JOIN ' . TABLE_PREFIX . 'links_favorites AS favorites ON (favorites.linkid = links.linkid AND favorites.userid = ' . $vbulletin->userinfo['userid'] . ')';
	}

	if ($vba_options['links_randonhome'] OR $vba_options['links_newonhome'] AND !$linksperms['canviewprivatedirs'])
	{
		$privdirs = fetch_private_directories();
		if ($privdirs)
		{
			$privatedirs = 'AND links.catid NOT IN(' . $privdirs . ')';
		}
	}

	if (intval($vba_options['links_newonhome']) AND $linksperms['canviewlinks'])
	{
		$getnew = $db->query("SELECT links.linkid, name, links.description, url, links.catid, username, links.userid, views, open, dateline, title, votenum, votetotal $postfields $subfields $favfields
				FROM " . TABLE_PREFIX . "links AS links
				LEFT JOIN " . TABLE_PREFIX . "links_categories AS links_categories ON (links.catid = links_categories.catid)
				$subjoin
				$favjoin
				WHERE valid = 1 AND suspended = 0 $privatedirs
				ORDER BY dateline DESC 
				LIMIT $vba_options[links_newonhome]");
		if ($db->num_rows($getnew))
		{
			$show['newlinks'] = true;
			while ($links = $db->fetch_array($getnew))
			{
				$newlinkbits .= construct_linkbits($links, 1);
			}
		}
	}

	if (intval($vba_options['links_randonhome']) AND $linksperms['canviewlinks'])
	{
		$getnew = $db->query("SELECT links.linkid, name, links.description, url, links.catid, username, links.userid, views, open, dateline, title, votenum, votetotal $postfields $subfields $favfields
				FROM " . TABLE_PREFIX . "links AS links
				LEFT JOIN " . TABLE_PREFIX . "links_categories AS links_categories ON (links.catid = links_categories.catid)
				$subjoin
				$favjoin
				WHERE valid = '1' AND suspended = '0' $privatedirs
				ORDER BY RAND()
				LIMIT $vba_options[links_randonhome]");
		if ($db->num_rows($getnew))
		{
			$show['randomlinks'] = true;
			while ($links = $db->fetch_array($getnew))
			{
				$randomlinkbits .= construct_linkbits($links, 1);
			}
		}
	}

	if ($vba_options['links_navbarhomelink'])
	{
		$navbits[''] = $vba_options['links_title'];
		$navbits = construct_navbits($navbits);
	}
	eval('$navbar = "' . fetch_template('navbar') . '";');
}
else
{
	$show['subdirs'] = true;
	$directoryjump = print_directory_jump($catid);

	foreach ($catinfo AS $navcat)
	{
		if ($navcat['catid'] == $catid)
		{
			$navinfo['title'] = stripslashes($navcat['title']);
			$navinfo['parentlist'] = $navcat['parentlist'];
		}
	}

	if ($vba_options['links_navbarhomelink'])
	{
		$navbits["$vba_options[links_homeurl]/index.php"] = $vba_options['links_title'];
	}
	$navbits = construct_dir_navbits($navinfo['parentlist']);
	$navbits = construct_navbits($navbits);
	eval('$navbar = "' . fetch_template('navbar') . '";');
}

if (defined('VBA_PORTAL'))
{
	eval('$HTML .= "' . fetch_template('ADV_LINKS') . '";');
	print_portal_output($home, $HTML);
}
else
{
	eval('print_output("' . fetch_template('ADV_LINKS') . '");');
}


?>