<?php
// ++=========================================================================++
// || vBadvanced Links Directory v1.0.1 (vB 3.5) - 17185
// ||  2003-2004 vBadvanced.com & PlurPlanet, LLC - All Rights Reserved
// || This file may not be redistributed in whole or significant part.
// || http://vbadvanced.com
// || Downloaded 14:49, Wed Oct 5th 2005
// || 3105590_051718507648
// ++ ========================================================================++

error_reporting(E_ALL & ~E_NOTICE);
define('NO_REGISTER_GLOBALS', 1);
define('GET_EDIT_TEMPLATES', true);

$specialtemplates = array(
	'smiliecache',
	'bbcodecache',
	'iconcache'
);

$globaltemplates = array(
	'ADV_LINKS_REPLY',
	'newreply_reviewbit'
);

$actiontemplates = array(
	'ratelink' => array(
		'adv_links_ratingpopup'
	)
);

$actiontemplates['none'] = &$actiontemplates['reply'];

$phrasegroups = array(
	'posting',
	'threadmanage'
);

require_once('./links_global.php');
require_once('./includes/functions_newpost.php');

if (empty($_REQUEST['do']))
{
	$_REQUEST['do'] = 'reply';
}

if ($_REQUEST['do'] == 'newreply')
{
	$_REQUEST['do'] = 'reply';
}

// ################### Function for mini-errors #################
function print_mini_error($errormessage)
{
	global $headinclude, $vbphrase, $stylevar;

	$errormessage = stripslashes(fetch_error($errormessage, PHRASETYPEID_ERROR));

	eval('print_output("' . fetch_template('adv_links_minierror') . '");');
	exit;
}	

// ############# Function To Rate Links #####################
function rate_link($vote, $linkid, $redirpage = '')
{
	global $db, $vbulletin, $ipaddress, $newpostid, $linksperms;

	if (!$linksperms['canratelinks'])
	{
		if ($redirpage == 'close')
		{
			eval(print_mini_error('adv_links_novotingperms'));
		}
		else
		{
			print_no_permission();
		}
	}

	if ($vote < 1 or $vote > 5)
	{
		if ($redirpage == 'close')
		{
			eval(print_mini_error('error_invalidvote'));
		}
		else
		{
			eval(standard_error(fetch_error('error_invalidvote')));
		}
	}

	switch($redirpage)
	{
		case close:
			$redirurl = 'reply.php?do=closebox';
			break;
		case post:
			$redirurl = 'showlink.php?$session[sessionurl]do=showdetails&amp;postid=$newpostid#post$newpostid';
		default :
			$redirurl = "showlink.php?$session[sessionurl]do=showdetails&amp;l=$linkid";
	}
	// Check For Duplicates
	if (fetch_bbarray_cookie('rating_linkid', $linkid))
	{
		if ($redirpage == 'close')
		{
			eval(print_mini_error('threadratevoted'));
		}
		else
		{
			eval(standard_error(fetch_error('threadratevoted')));
		}
	}

	if ($rating = $db->query_first("SELECT rateid, rating FROM " . TABLE_PREFIX . "links_rate WHERE linkid = '$linkid' AND " . iif($vbulletin->userinfo['userid'], 'userid = \'' . $vbulletin->userinfo['userid'] . '\'', "ipaddress = '" . stripslashes($ipaddress) . "'") . ""))
	{
		if (!$vbulletin->options['votechange'])
		{
			if ($redirpage == 'close')
			{
				eval(print_mini_error('threadratevoted'));
			}
			else
			{
				eval(standard_error(fetch_error('threadratevoted')));
			}
		}
		else
		{
			if ($vote != $rating['rating'])
			{
				$newvote = $vote - $rating['rating'];
				$db->query_write("UPDATE " . TABLE_PREFIX . "links_rate SET rating = '$vote' WHERE rateid = '$rating[rateid]'");
				$db->query_write("UPDATE " . TABLE_PREFIX . "links SET votetotal = votetotal + $newvote WHERE linkid = '$linkid'");
			}
			$vbulletin->url = $redirurl;
			eval(print_standard_redirect('redirect_threadrate_update'));
		}
	}
	else
	{
		// No duplicates, so insert the rating
		$db->query_write("INSERT INTO " . TABLE_PREFIX . "links_rate (linkid, rating, userid, ipaddress) VALUES ('$linkid', '$vote', '" . $vbulletin->userinfo['userid'] . "', '" . addslashes($ipaddress) . "')");
		$db->query_write("UPDATE " . TABLE_PREFIX . "links SET votetotal = votetotal + $vote, votenum = votenum + 1 WHERE linkid = '$linkid'");
		set_bbarray_cookie('rating_linkid', $linkid, $vote, 1);

		$vbulletin->url = $redirurl;
		eval(print_standard_redirect('redirect_threadrate_add'));
	}
}

// ########################## Do Reply to Link #############################
if (in_array($_POST['do'], array('doreply', 'doedit')))
{
	$linkid = $vbulletin->input->clean_gpc('p', 'linkid', TYPE_INT);
	$catid = $vbulletin->input->clean_gpc('p', 'catid', TYPE_INT);
	$postid = $vbulletin->input->clean_gpc('p', 'postid', TYPE_INT);
	$vote = $vbulletin->input->clean_gpc('p', 'vote', TYPE_INT);
	$wysiwyg = $vbulletin->input->clean_gpc('p', 'wysiwyg', TYPE_BOOL);
	$message = $vbulletin->input->clean_gpc('p', 'message', TYPE_STR);

	if (!$linksperms['canreplytolinks'])
	{
		print_no_permission();
	}

	$cat = $db->query_first("
		SELECT name, title, options, newpostemail 
		FROM " . TABLE_PREFIX . "links AS links
		LEFT JOIN " . TABLE_PREFIX . "links_categories AS links_categories USING (catid)
		WHERE linkid = '$linkid'
	");

	$diropts = construct_dir_opts($cat['catid'], $cat['options']);

	if (!$diropts['open_for_posts'])
	{
		eval(standard_error(fetch_error('adv_links_not_open_for_posts')));
	}

	$post['title'] = htmlspecialchars(fetch_censored_text($_POST['title']));
	$post['username'] = $_POST['username'];

	// WYSIWYG
	if ($wysiwyg)
	{
		require_once('./includes/functions_wysiwyg.php');
		$post['message'] = convert_wysiwyg_html_to_bbcode($message);
	}

	// Normal editor
	else
	{
		$post['message'] = $message;
	}

	// Quote from quickreply
	if ($_POST['quickreply'])
	{
		$postinfo = $db->query_first("SELECT username, title, pagetext FROM " . TABLE_PREFIX . "links_posts WHERE postid = '$postid'");

		$vbulletin->options['quotetitle'] = 0;
		if ($vba_options['links_quotetitle'] AND !$post['title'])
		{
			$vbulletin->options['quotetitle'] = 1;
		}
		$post['title'] = fetch_quote_title($post['title'], $postinfo['title']);

		$originalposter = fetch_quote_username($postinfo['username']);
		$pagetext = strip_quotes($postinfo['pagetext']);
		eval('$quotemessage = "' . fetch_template('newpost_quote', 1, 0) . '";');
		$post['message'] = "$quotemessage $post[message]";
		$newpost['message'] = "$quotemessage $post[message]";
	}

	// Insert title if necessary
	if (!$post['title'] AND $_POST['fromquickreply'] AND $vba_options['links_quotetitle'])
	{
		$vbulletin->options['quotetitle'] = 1;
		$post['title'] = fetch_quote_title($post['title'], $cat['name']);
	}

	// Smilies
	$post['disablesmilies'] = 1;
	if ($vba_options['links_allowsmilie'])
	{
		$post['disablesmilies'] = $_POST['disablesmilies'];
	}

	$post['enablesmilies'] = 0;
	if (!$post['disablesmilies'])
	{
		$post['enablesmilies'] = 1;
	}

	// Check for errors
	$errors = array();

	$postlength = strlen($post['message']);

	// Check message length
	if (!$post['message'] AND $vbulletin->options['postminchars'])
	{
		eval('$errors[] = "' . fetch_error('nosubject') . '";');
	}

	if ($vbulletin->options['postminchars'] AND $postlength < $vbulletin->options['postminchars'])
	{
		eval('$errors[] = "' . fetch_error('tooshort', $postlength, $vbulletin->options['postminchars']) . '";');
	}
	else if ($vbulletin->options['postmaxchars'] AND $postlength > $vbulletin->options['postmaxchars'])
	{
		eval('$errors[] = "' . fetch_error('toolong', $postlength, $vbulletin->options['postmaxchars']) . '";');
	}

	// Guest username check
	if (!$vbulletin->userinfo['userid'])
	{
		if (!$post['username'])
		{
			eval('$errors[] = "' . fetch_error('nousername') . '";');
		}
		else if (strlen($post['username']) < $vbulletin->options['minuserlength'])
		{
			eval('$errors[] = "' . fetch_error('usernametooshort', $vbulletin->options['minuserlength']) . '";');
		}
		else if (strlen($post['username']) > $vbulletin->options['maxuserlength'])
		{
			eval('$errors[] = "' . fetch_error('usernametoolong', $vbulletin->options['maxuserlength']) . '";');
		}
		else if ($dupecheck = $db->query_first("SELECT userid FROM " . TABLE_PREFIX . "user WHERE username = '" . addslashes(htmlspecialchars($post['username'])) . "'"))
		{
			eval('$errors[] = "' . fetch_error('usernametaken', addslashes(htmlspecialchars($post['username'])), $vbulletin->session->vars['sessionurl']) . '";');
		}
	}

	$post['message'] = fetch_censored_text($post['message']);

	if ($_POST['parseurl'])
	{
		$post['message'] = convert_url_to_bbcode($post['message']);
	}

	// Duplicate post / flood check
	if ($_REQUEST['do'] == 'doreply' AND $vbulletin->userinfo['userid'])
	{
		$lpost = $db->query_first("SELECT postid, title, pagetext, dateline FROM " . TABLE_PREFIX . "links_posts WHERE userid = '" . $vbulletin->userinfo['userid'] . "' ORDER BY dateline DESC LIMIT 1");
		
		// Have the same post, so just redirect the user
		if ($post['message'] == $lpost['pagetext'] AND $post['title'] == $lpost['title'])
		{
			$vbulletin->url = "showlink.php?$session[sessionurl]do=showdetails&amp;l=$linkid&amp;postid=$lpost[postid]#post$lpost[postid]";
			eval(print_standard_redirect('redirect_postthanks'));
		}	

		$errors = array();

		// Have flooding, so display error
		if ($vbulletin->options['floodchecktime'] AND !$_POST['preview'] AND (TIMENOW - $lpost['dateline']) <= $vbulletin->options['floodchecktime'])
		{
			eval('$errors[] = "' . fetch_error('postfloodcheck', $vbulletin->options['floodchecktime'], ($vbulletin->options['floodchecktime'] - (TIMENOW - $lpost['dateline']))) . '";');
		}
	}

	// Errors!
	if ($errors)
	{
		$postpreview = construct_errors($errors);
		construct_checkboxes($_POST);
		$newpost['message'] = htmlspecialchars($post['message']);
		$_REQUEST['l'] = $linkid;

		if ($_POST['do'] == 'doedit')
		{
			$_REQUEST['do'] = 'editpost';
		}
		else
		{
			$_REQUEST['do'] = 'reply';
		}
	}

	// Just previewing
	else if ($_POST['preview'])
	{

		if (!$diropts['allow_post_smilies'] OR !$vba_options['links_allowsmilie'])
		{
			$post['disablesmilies'] = 1;
		}

		$postpreview = process_post_preview($post);
		$newpost['message'] = $post['message'];
		construct_checkboxes($_POST);

		$_REQUEST['l'] = $linkid;
		if ($_POST['do'] == 'doedit')
		{
			$_REQUEST['do'] = 'editpost';
		}
		else
		{
			$_REQUEST['do'] = 'reply';
		}
	}
	else
	{
		// Everything's good, so get ready to insert
		if ($_REQUEST['do'] == 'doreply')
		{

			if ($linksperms['moderatelinkposts'])
			{
				$visible = 0;
			}
			else
			{
				$visible = 1;
				send_subscribed_posts($linkid);
			}

			$sendmailto = explode(' ', $cat['newpostemail']);

			if ((!$visible OR $vba_options['links_newlinkemail_all']) AND !empty($sendmailto))
			{
				$cat['title'] = stripslashes($cat['title']);
				$link['name'] = stripslashes($cat['name']);
				foreach ($sendmailto AS $email)
				{
					eval(fetch_email_phrases('adv_links_newpost', 0));
					vbmail(trim($email), $subject, $message);
				}
			}


			// Insert the post
			$db->query_write("INSERT INTO " . TABLE_PREFIX . "links_posts (linkid, title, pagetext, userid, username, dateline, ipaddress, iconid, allowsmilie, showsignature, visible) VALUES ('$linkid', '" . addslashes($post['title']) . "', '" . addslashes($post['message']) . "', '" . $vbulletin->userinfo['userid'] . "', '" . $vbulletin->userinfo['username'] . "', '" . time() . "', '" . addslashes(IPADDRESS) . "', '$_POST[iconid]', '$post[enablesmilies]', '$_POST[signature]', '$visible')");
	
			if ($visible == 1)
			{
				$newpostid = $db->insert_id();
		
				// Update link info
				$db->query_write("UPDATE " . TABLE_PREFIX . "links SET posts = posts+1, lastpostuserid = '" . $vbulletin->userinfo['userid'] . "', lastpostusername = '" . $vbulletin->userinfo['username'] . "', lastpostdateline = '" . time() . "' WHERE linkid = '$linkid'");

				// Update directory info
				$db->query_write("UPDATE " . TABLE_PREFIX . "links_categories SET postcount = postcount+1 WHERE catid = '$catid'");
		
				// Update user post counts
				if ($vba_options['links_update_postcount'])
				{
					$db->query_write("UPDATE " . TABLE_PREFIX . "user SET posts = posts+1 WHERE userid = '" . $vbulletin->userinfo['userid'] . "'");
				}
			}
			// Add vote if necessary
			if ($_REQUEST['vote'] > 0)
			{
				rate_link($vote, $_POST['linkid'], 'post');
			}
		}
		else
		{
			// We're editing, so update the post
			$db->query_write("UPDATE " . TABLE_PREFIX . "links_posts SET title = '" . addslashes($post['title']) . "', pagetext = '" . addslashes($post['message']) . "', iconid = '$_POST[iconid]', allowsmilie = '$post[enablesmilies]', showsignature = '$_POST[signature]' WHERE postid = '$_POST[postid]'");
			$newpostid = $_POST['postid'];
		}
		$vbulletin->url = "showlink.php?$session[sessionurl]do=showdetails&amp;l=$_POST[linkid]&amp;postid=$newpostid#post$newpostid";

		if ($_POST['do'] == 'doreply')
		{
			eval(print_standard_redirect('redirect_postthanks'));
		}
		else
		{
			eval(print_standard_redirect('redirect_editthanks'));
		}
	}
}

// ########################## Reply to Link #############################
if (in_array($_REQUEST['do'], array('reply', 'editpost')))
{
	$postid = $vbulletin->input->clean_gpc('r', 'postid', TYPE_INT);
	$p = $vbulletin->input->clean_gpc('r', 'p', TYPE_INT);

	if (!$linksperms['canreplytolinks'])
	{
		print_no_permission();
	}

	if (isset($p) AND $p != 0)
	{
		$postid = $p;
	}

	// Get post info for quoting or editing
	if (intval($postid))
	{
		$post = $db->query_first("SELECT postid, linkid, title, pagetext, username, userid, showsignature, allowsmilie, iconid FROM " . TABLE_PREFIX . "links_posts WHERE postid = '$postid'");

		if ($_REQUEST['do'] == 'editpost')
		{
			if (($vbulletin->userinfo['userid'] != $post['userid'] AND !$linksperms['caneditotherslinkposts']) OR !$linksperms['caneditlinkposts'])
			{
				print_no_permission();
			} 

			$show['editpost'] = true;
			if (!$_POST['preview'])
			{
				$newpost['message'] = htmlspecialchars($post['pagetext']);
			}
		}
		else
		{
			// Quote from quickreply
			if (!$_POST['quickreply'])
			{
				$originalposter = fetch_quote_username($post['username']);
				$pagetext = trim(htmlspecialchars(strip_quotes($post['pagetext'])));
				eval('$newpost[\'message\'] = "' . fetch_template('newpost_quote', 1, 0) . '";');
			}
		}

		$linkid = $post['linkid'];
	}

	// Get link info
	$link = $db->query_first("
			SELECT linkid, name, open, title, links.catid, parentlist, options
			FROM " . TABLE_PREFIX . "links AS links
			LEFT JOIN " . TABLE_PREFIX . "links_categories AS links_categories ON (links.catid = links_categories.catid)
			WHERE linkid = '$linkid'
	");

	check_link_id($link['linkid']);
	check_directory_permissions($link['catid']);
	$diropts = construct_dir_opts($link['catid'], $link['options']);

	if (!$diropts['open_for_posts'])
	{
		eval(standard_error(fetch_error('adv_links_not_open_for_posts')));
	}

	// Check to see if it's open
	if (!is_directory_mod($link['parentlist']) AND !$link['open'])
	{
		print_no_permission();
	}

	$category = stripslashes($link['title']);
	$linkname = stripslashes($link['name']);

	// Construct voting box for preview
	$votesel = array();
	$vote = intval($_POST['vote']);
	$votesel["$vote"] = 'selected="selected"';

	$navbits = construct_dir_navbits($link['parentlist']);
	$navbits["showlink.php?$session[sessionurl]do=showdetails&amp;l=$link[linkid]"] = $linkname;

	if ($_POST['iconid'])
	{
		$post['iconid'] = intval($_POST['iconid']);
	}

	if ($_REQUEST['do'] == 'editpost')
	{
		$navbits[''] = $vbphrase['edit_post'];

		if (!isset($checked['parseurl']))
		{
			$checked['parseurl'] = 'checked="checked"';
		}
	
		if ($post['showsignature'])
		{
			$checked['signature'] = 'checked="checked"';
		}

		if (!$post['allowsmilie'])
		{
			$checked['disablesmilies'] = 'checked="checked"';
		}

		if (($linksperms['candeletelinkposts'] AND $vbulletin->userinfo['userid'] == $post['userid']) OR $linksperms['candeleteotherslinkposts'] OR is_directory_mod($link['parentlist']))
		{
			$show['deleteopt'] = true;
			$show['editpost'] = true;
		}
	}
	else
	{
		// Get title if necessary
		$vbulletin->options['quotetitle'] = 0;
		if ($vba_options['links_quotetitle'])
		{
			$vbulletin->options['quotetitle'] = 1;
		}
		$post['title'] = fetch_quote_title($post['title'], $linkname);

		// Check URL box if isn't set
		if (!isset($checked['parseurl']))
		{
			$checked['parseurl'] = 'checked="checked"';
		}
	
		// Signature check box
		if (trim($vbulletin->userinfo['signature']) AND !$preview AND !isset($checked['signature']))
		{
			$checked['signature'] = 'checked="checked"';
		}


		$navbits[''] = $vbphrase['reply_to_link'];

		// Rating option
		if ($linksperms['canratelinks'])
		{
			$show['ratingopts'] = true;
		}

		// Get replies for topic review
		if ($linksperms['canviewlinkreplies'])
		{
			$countposts = $db->query_first("SELECT COUNT(*) AS count FROM " . TABLE_PREFIX . "links_posts WHERE linkid = '$linkid'");
		}

		if ($diropts['allow_post_smilie'])
		{
			$query['getsmilie'] = true;
		}

		if ($countposts['count'])
		{
			$getposts = $db->query("
					SELECT pagetext, username, dateline " . iif($query['getsmilie'], ', allowsmilie') . " 
					FROM " . TABLE_PREFIX . "links_posts 
					WHERE linkid = '$linkid' AND visible != 0 
					ORDER BY dateline DESC
					LIMIT " . $vbulletin->options['maxposts']
			);
			if ($db->num_rows($getposts))
			{
				require_once('./includes/class_bbcode.php');
				$bbcode_parser =& new vB_BbCodeParser($vbulletin, fetch_tag_list());
				$show['reviewbits'] = true;
				while ($posts = $db->fetch_array($getposts))
				{
					$posttime = vbdate($vbulletin->options['timeformat'], $posts['dateline']);
					$postdate = vbdate($vbulletin->options['dateformat'], $posts['dateline']);
					$username = $posts['username'];
					$reviewmessage = $bbcode_parser->do_parse($posts['pagetext'], $diropts['allow_post_html'], $post['allowsmilie'], $diropts['allow_post_bbcode'], $diropts['allow_post_bbimgcode']);
					eval('$reviewbits .= "' . fetch_template('newreply_reviewbit') . '";');
				}
			}
			if ($countposts['count'] > $vbulletin->options['maxposts'])
			{
				$show['reviewmore'] = true;
			}
			$db->free_result($getposts);
			unset($posts);
		}
	}

	require_once('./includes/functions_editor.php');
	$textareacols = fetch_textarea_width();

	$iconbits = construct_icons(intval($_POST['iconid']), iif($vba_options['links_allowicons'] AND $diropts['allow_post_icons'], 1, 0));
	$selectedicon['src'] = str_replace($vbulletin->options['cleargifurl'], $vbulletin->options['bburl'] . '/' . $vbulletin->options['cleargifurl'], $selectedicon['src']);

	// Editor & message area
	$editorid = construct_edit_toolbar($newpost['message'], 0, 0, $diropts['allow_post_smilies'],  1, 0);

	$messagearea = str_replace('"clientscript', '"' . $vbulletin->options['bburl'] . '/clientscript', $messagearea);

	eval('$usernamecode = "' . fetch_template('newpost_usernamecode') . '";');

	$navbits = construct_navbits($navbits);
eval('$navbar = "' . fetch_template('navbar') . '";');

	eval('print_output("' . fetch_template('ADV_LINKS_REPLY') . '");');
}

// ############################## Delete Post #############################
if ($_POST['do'] == 'dodeletepost')
{
	$postid = $vbulletin->input->clean_gpc('p', 'postid', TYPE_INT);
	$deletepost = $vbulletin->input->clean_gpc('p', 'deletepost', TYPE_INT);

	$post = $db->query_first("SELECT postid, posts.userid, posts.linkid, links.catid, parentlist
			FROM " . TABLE_PREFIX . "links_posts AS posts
			INNER JOIN " . TABLE_PREFIX . "links AS links USING (linkid)
			INNER JOIN " . TABLE_PREFIX . "links_categories AS categories USING (catid)
			WHERE postid = '$postid'
	");

	if (!$post['postid'])
	{
		$idname = $vbphrase['post'];
		eval(standard_error(fetch_error('noid', $vbphrase['post'])));
	}

	if (($post['userid'] != $vbulletin->userinfo['userid'] AND !$linksperms['candeleteotherslinkposts']) OR !$linksperms['candeletelinkposts'] AND !is_directory_mod($post['parentlist']))
	{
		print_no_permission();
	}

	if (!$deletepost)
	{
		eval(standard_error(fetch_error('adv_links_nodelete', $vbphrase['message'])));
	}
	else
	{
		$db->query_write("DELETE FROM " . TABLE_PREFIX . "links_posts WHERE postid = '$post[postid]'");

		$lastpost = $db->query_first("SELECT dateline, username, userid FROM " . TABLE_PREFIX . "links_posts WHERE linkid = '$post[linkid]' ORDER BY dateline LIMIT 1");

		$db->query_write("UPDATE " . TABLE_PREFIX . "links SET posts = posts-1, lastpostdateline = '$lastpost[dateline]', lastpostuserid = '$lastpost[userid]', lastpostusername = '$lastpost[username]' WHERE linkid = '$post[linkid]'");

		$db->query_write("UPDATE " . TABLE_PREFIX . "links_categories SET postcount = postcount-1 WHERE catid = '$post[catid]'");

		$vbulletin->url = "showlink.php?$session[sessionurl]do=showdetails&amp;l=$post[linkid]";
		eval(print_standard_redirect('adv_links_posts_deleted'));
	}
}

// ############################### Rate Link ###############################
if ($_REQUEST['do'] == 'ratelink')
{
	$link = $db->query_first("SELECT linkid, name, catid FROM " . TABLE_PREFIX . "links WHERE linkid = '$linkid'");

	check_link_id($link['linkid']);

	check_directory_permissions($link['catid']);

	$linkname = stripslashes($link['name']);

	eval('print_output("' . fetch_template('adv_links_ratingpopup') . '");');
}

// ############################### Do Rate Link ###############################
if ($_POST['do'] == 'rate')
{
	$vote = $vbulletin->input->clean_gpc('p', 'vote', TYPE_INT);
	$linkid = $vbulletin->input->clean_gpc('p', 'linkid', TYPE_INT);
	$redirpage = $vbulletin->input->clean_gpc('p', 'redirpage', TYPE_NOHTML);

	rate_link($vote, $linkid, $redirpage);
}

// ############################### Close Rating Box ###############################
if ($_REQUEST['do'] == 'closebox')
{
	eval('print_output("' . fetch_template('adv_links_rating_closebox') . '");');
}

?>